SP!
RUNTIME
EMPTY
SHOWFREE
HEX
HERE .
4000 GETMEM DROP
SHOWFREE

HERE .

: CHARGESTUFF ;
SHOWFREE


// tentative i/o map.
// AD7 BATTERY MON.

FFFFF4A0 CONSTANT PIO_OWER // Output Write Enable Write-only 
FFFFF4A4 CONSTANT PIO_OWDR // Output Write Disable Write-only 

INCLUDE ..\include\IO.FTH
INCLUDE ..\include\LCD.FTH
INCLUDE ..\include\RTT.FTH
INCLUDE ..\include\STATE.FTH
INCLUDE ..\include\ADC.FTH
." Includes done" CR
FORTH DEFINITIONS
80 CONSTANT BATMASK // Bit mask for battery adc channel.

DECIMAL
VARIABLE VTHRES
	1380 2 /  VTHRES ! // Battery charge threshold when calibrated for 2 mV per bit.
HEX

: RTTSTAT 
CR
	." RTTSR = " RTTSR U? CR	
	." RTTVAL = " RTTVAL U? CR
	." RTTALARM = " RTTALARM  U? CR
	." RTTMODE = " RTTMODE  U? CR
;

: ADCSTAT 
CR
	." ADCSR = " ADCSR U? CR	
	." ADCMR = " ADCMR U? CR
	." ADCLCDR = " ADCLCDR  U? CR
	." ADCIMR = " ADCIMR  U? CR
;

: INITADC 
	80 ADCCHER !
	04040400 ADCMR ! 
;


: RESETRTT
	RTTRSTBIT 20 + RTTMODE !
	BEGIN 
		RTTVAL @ 0= 
	UNTIL
;
RESETRTT

: PIO_PDSR@ PIO_PDSR @ ;

: GETBUTTON 
	PIO_PDSR@
	1B RSHIFT 1F XOR
;

: .BUT GETBUTTON . ;

: PDSR@ETC
	PIO_PDSR@ AND 0=
;
DECIMAL 
: .VOLTS
 2 * 100  U/MOD (.) #> 46 EMIT
	DUP 10 < IF 48 EMIT THEN // PAD WITH 0
 . ." Volts " 
;
HEX
RUNTIME
// ******************* Data logging stuff *********************************
1000 CONSTANT LOGSIZE // Size in bytes 
LABEL LOGARRAY
LOGSIZE ALLOT
VARIABLE LOGINDEX	// Index in 16 bit words
VARIABLE LOGINTERVAL
DECIMAL
60000 LOGINTERVAL !
HEX
: 2C! // WORD16 ADDR -- MT; Store 16 bit word as LL HH 
	OVER FF AND OVER C! // Store low
	1+ SWAP 8 RSHIFT SWAP C!
;

: 2C@ // ADDR -- WORD16 // Fetch word
	DUP C@
	SWAP 1+ C@ 8 LSHIFT +
;
DECIMAL
: DUMPLOG
BASE @
DECIMAL
	0 LOGINDEX !
	BEGIN
		LOGARRAY LOGINDEX @ + 2C@ 20 * . CR
		2 LOGINDEX +!
		LOGINDEX @ LOGSIZE >
		LOGARRAY LOGINDEX @ + 2C@ 0=
		OR
	UNTIL
BASE !
;
HEX
: LOG2FILE
	CAPTURE DUMPLOG
	CAPTURE
;

// Define local variable and code.

VARIABLE LOG-ALARM

: LOG-PREP
	LOGARRAY LOGSIZE ERASE
	0 LOGINDEX !
	RTTVAL @  LOG-ALARM !
;

: LOG-CODE
	LOG-ALARM @ RTTVAL @ < IF						// is it time to 
		LOGINDEX @ LOGSIZE >			// Chech index overflow
		IF
			0 LOGINDEX !			// if overflow wrap to zero
		THEN
		BATMASK READADCX
		LOGARRAY LOGINDEX @ + 2C!
		2 LOGINDEX +!
		LOGINTERVAL @ LOG-ALARM +!	
	THEN
;


// *********************** LED table and code ******************************

DEFINE_STATES

STATEDEF LEDON_STATE
STATEDEF LEDOFF_STATE

DEFINE_STATE_TABLE LED_SMT

// Define local variable and code.

VARIABLE LED-ALARM
VARIABLE VBAT

: LED-PREP
	LEDOFF_STATE LED_SMT CHANGESTATE 
;

: READBATV
	BATMASK READADCX
	DUP .VOLTS >LINE1
	DUP VBAT !
;

: LEDOFF-CODE

	LED_SMT ?NEWSTATE IF							// Is this state new?
		LEDOFF	
		READBATV
		VTHRES @ > IF								// have we reached threshold?
			RTTVAL @ 1000 + LED-ALARM !
		ELSE
			RTTVAL @ VBAT @ + LED-ALARM  !
		THEN
	THEN
	
	LED-ALARM @ RTTVAL @ < IF						// 
		VBAT @ VTHRES @ > IF
			READBATV
			VTHRES @ > IF							// have we still over threshold?
				RTTVAL @ 1000 + LED-ALARM !
			ELSE
				RTTVAL @ VBAT @ + LED-ALARM !
			THEN				
		ELSE
			LEDON_STATE LED_SMT CHANGESTATE 		// yes, change state			
		THEN
	THEN
;

: LEDON-CODE
	LED_SMT ?NEWSTATE IF							// Is this state new?
		LEDON										// back light on
		RTTVAL @ VTHRES @ VBAT @ - + LED-ALARM !
	THEN
	LED-ALARM @ RTTVAL @ < IF						// is it time to 
		LEDOFF_STATE LED_SMT CHANGESTATE 			// yes, change state
	THEN
;

// Build table

LED_SMT 	LEDON_STATE 	INSERT_STATE 	LEDON-CODE
LED_SMT 	LEDOFF_STATE 	INSERT_STATE 	LEDOFF-CODE

// *********************** Back light table and code ******************************
// BL STATUS STRINGS ----------------------------------------------------

DEFINE_CODES

STR_CODE_DEF BLON_C
STR_CODE_DEF BLOFF_C

STRCONSTANT BLONSTR	Back light on   "
STRCONSTANT BLOFFSTR Back light off  "

DEFINE_STRING_TABLE BL_STRINGS

BL_STRINGS BLON_C BLONSTR INSERT_STRING 
BL_STRINGS BLOFF_C BLOFFSTR INSERT_STRING

DEFINE_STATES

STATEDEF BLON_STATE
STATEDEF BLOFF_STATE

DEFINE_STATE_TABLE BL_SMT

// Define code.

VARIABLE BL-ALARM
DECIMAL 

VARIABLE BL-DELAY
30000 BL-DELAY !

HEX

: BL-PREP
//	RTTVAL @ BL-ALARM !
	BLON_STATE BL_SMT CHANGESTATE 
;

: BLON-CODE
	BL_SMT ?NEWSTATE IF							// Is this state new?
		RTTVAL @ BL-DELAY @ + BL-ALARM !						// Set BL turn off alarm
		BLON										// back light on
		BLON_C BL_STRINGS CHANGECODE				// set the string for i/o
	THEN
	GETBUTTON IF
			RTTVAL @ BL-DELAY @ + BL-ALARM !		// Set BL turn off alarm
	THEN
	BL-ALARM @ RTTVAL @ < IF						// is it time to read ADC
			BLOFF_STATE BL_SMT CHANGESTATE 			// yes, change state
	THEN
;

: BLOFF-CODE
	BL_SMT ?NEWSTATE IF								// Is this state new?
		BLOFF										// back light off
		BLOFF_C BL_STRINGS CHANGECODE				// set the string for i/o
	THEN
	GETBUTTON IF
		BLON_STATE BL_SMT CHANGESTATE 				// yes, change state			
	THEN
;

// Build table

BL_SMT 	BLON_STATE 	INSERT_STATE 	BLON-CODE
BL_SMT 	BLOFF_STATE INSERT_STATE 	BLOFF-CODE

// *********************** Charger table and code ******************************
// STATUS STRINGS ----------------------------------------------------

DEFINE_CODES

STR_CODE_DEF CHARGING_C
STR_CODE_DEF CHARGED_C

STRCONSTANT CHARGINGSTR	Charging        "
STRCONSTANT CHARGEDSTR	Charged         "

DEFINE_STRING_TABLE CHARGE_STRINGS

CHARGE_STRINGS CHARGING_C CHARGINGSTR INSERT_STRING 
CHARGE_STRINGS CHARGED_C CHARGEDSTR INSERT_STRING

// --------------------------------------------------
DEFINE_STATES

STATEDEF CHARGING_STATE
STATEDEF CHARGED_STATE


DEFINE_STATE_TABLE CHARGE_SMT

// Define code.

VARIABLE CHARGEALARM
DECIMAL 

VARIABLE DELAY1
1000 DELAY1 !
VARIABLE DELAY2
30000 DELAY2 !

HEX

: CHARGER-PREP
	BLON LCDCLR
	RTTVAL @ CHARGEALARM !
	BATMASK READADCX
	VTHRES @ > IF
		CHARGED_STATE CHARGE_SMT CHANGESTATE 
	ELSE
		CHARGING_STATE CHARGE_SMT CHANGESTATE 
	THEN
;

: CHARGING-CODE
	CHARGE_SMT ?NEWSTATE IF							// Is this state new?
		DELAY1 @ CHARGEALARM +!						// Set the next ADC sample time
		RELAYOFF 							// relay off - pass current.
		CHARGING_C CHARGE_STRINGS CHANGECODE		// set the string for i/o
	THEN
	
	CHARGEALARM @ RTTVAL @ < IF					// is it time to read ADC
		BATMASK READADCX							// yes read it.

		VTHRES @ > IF									// have we reached threshold?
			CHARGED_STATE CHARGE_SMT CHANGESTATE 	// yes, change state
		ELSE
			DELAY1 @ CHARGEALARM +!					// No - set new sample time.
		THEN
	THEN
;

: CHARGED-CODE
	CHARGE_SMT ?NEWSTATE IF							// Is this state new?
		DELAY2 @ CHARGEALARM +!						// Set the next ADC sample time
		RELAYON 								// relay on - block current.
		CHARGED_C CHARGE_STRINGS CHANGECODE		// set the string for i/o
	THEN
	
	CHARGEALARM @ RTTVAL @ < IF						// is it time to read ADC
		BATMASK READADCX							// yes read it.
		VTHRES @ < IF									// have we reached threshold?
			CHARGING_STATE CHARGE_SMT CHANGESTATE 	// yes, change state
		ELSE
			DELAY2 @ CHARGEALARM +!					// No - set new sample time.
		THEN
	THEN
;

// Build table

CHARGE_SMT 	CHARGED_STATE 	INSERT_STATE 	CHARGED-CODE
CHARGE_SMT 	CHARGING_STATE 	INSERT_STATE 	CHARGING-CODE

// ------------------------------------------------------------------

: CASES .S ." State " CHARGE_SMT @ U? CR
	BATMASK READADCX .VOLTS CR ;
: CASEDEF ." Unknown command type ? for help" CR ;
: DOEXIT DROP 1 ;

: HELP 
	." ? for help" CR
	." S for status" CR 
	." X to exit to FORTH" CR 
;

DEFINE_CASE_TABLE CMDTAB

53 INSERTCASE CASES
3F INSERTCASE HELP
58 INSERTCASE DOEXIT
CMDTAB DEFAULTCASE CASEDEF
CMDTAB ENDCASE

: UPCASE
	DUP
	61 7A WITHIN IF 20 - THEN
;

: RUNCHARGER
	DECIMAL
	LCDCLR
	CHARGER-PREP
	BL-PREP
	LED-PREP
	LOG-PREP
	0
	BEGIN
		KEYHIT
				IF KEY UPCASE CR
				CMDTAB EXECUTECASE 
		THEN
		
		CHARGE_SMT RUN_SM 
		CHARGE_STRINGS ?NEWCODE IF
				CHARGE_STRINGS ."CODE >LINE2
				CHARGE_STRINGS ."CODE CR
		THEN
		
		BL_SMT RUN_SM 
		BL_STRINGS ?NEWCODE IF
				BL_STRINGS ."CODE CR
		THEN
		
		LED_SMT RUN_SM 	
		LOG-CODE	

	DUP UNTIL
	DROP
HEX
	RELAYOFF
	." type 'RUNCHARGER' to re-enter the command processor" CR
//	ABORT
;

: ?SERV
	FLASHLED
	SET2SERV
	PINGSERV
	IF ABORT EXIT THEN
; 

: TRYSERV 
	INIT
	BLK@ IF BLK@ 4 + CLOSEFP THEN
	CONFIGURE
	4 0 DO
		BASE_US0 *USART !
		?SERV
		BASE_US1 *USART !
		?SERV	
	LOOP
;

: BOOTCHARGE

	RESETRTT
	INITADC
	INITLCD
	." EMFORTH Charger"
	LINE1 LCDCR 
	." Ver1.02 MT-256 " 
	LINE2 LCDCR 
	TRYSERV	
	BASE_US0 *USART !
	//  Baud Rate Divisor 38.4Kbd with 48mhz clock = 78, 115 = 26, 9600 - 312
	[ DECIMAL ] 312 [ HEX ]
	BASE_US0 US_BRGR + !
	SET2DUMB
//	BLON
	RUNCHARGER
	ABORT
;

: FLASHIT 
	[ ' BOOTCHARGE LITERAL ] *COLD !
	MIRROR1
;

ECHO ON
RTTSTAT

.S

INITADC 
READADC .
ADCSTAT
: TEST 100 0 DO READADC . CR LOOP ;

 RUNCHARGER

// To save prog to flash use FLASHIT !!NOT!! MIRROR1.

