// Demo2 - using a state machine in standard FORTH.
// flash led based on real timer - exit on button down
// tested on olimex mt-256
SP!
RUNTIME
EMPTY
HEX
4000 GETMEM DROP

INCLUDE ..\include\IO.FTH
INCLUDE ..\include\RTT.FTH
VARIABLE ALARMTIME
VARIABLE STATE

: GETBUTTON 			// mt -- buttons ; read mt-246 buttons
	PIO_PDSR @
	1B RSHIFT 1F XOR
;

: RESETRTT							// set up the real time timer
	RTTRSTBIT 20 + RTTMODE !
	BEGIN 
		RTTVAL @ 0= 
	UNTIL
;

: ONSTATECODE
		ALARMTIME @ RTTVAL @ < 		// check the real time timer
		IF
			1 STATE !				// Change the state
			LEDOFF					// turn led off.
			200 ALARMTIME +!		// set new alarm time
		THEN
;

: OFFSTATECODE
		ALARMTIME @ RTTVAL @ < 		// check the real time timer
		IF
			0 STATE !				// Change the state
			LEDON					// turn led on.
			40 ALARMTIME +!			// set new alarm time
		THEN
;

: RUNFSM
	STATE @ IF
		OFFSTATECODE
	ELSE
		ONSTATECODE
	THEN
;

: FLASHDEMO
	RESETRTT						// set up the real time timer
	RTTVAL @ ALARMTIME !			// set initial alarm time
	BEGIN 
		RUNFSM						// run one interation of the state machine
	GETBUTTON UNTIL					// Repeat until button pushed.
;

FLASHDEMO
