// Demo3 - using a state machine in standard FORTH.
// flash led based on real timer - exit on button down
// tested on olimex mt-256
SP!
RUNTIME
EMPTY
HEX
4000 GETMEM DROP

INCLUDE ..\include\IO.FTH
INCLUDE ..\include\RTT.FTH
INCLUDE ..\include\STATE.FTH


: GETBUTTON 			// mt -- buttons ; read mt-246 buttons
	PIO_PDSR @
	1B RSHIFT 1F XOR
;

: RESETRTT							// set up the real time timer
	RTTRSTBIT 20 + RTTMODE !
	BEGIN 
		RTTVAL @ 0= 
	UNTIL
;

DEFINE_STATES

STATEDEF LEDON_STATE
STATEDEF LEDOFF_STATE

DEFINE_STATE_TABLE LED_SMT

// Define local variable and code.

VARIABLE ALARMTIME

: LEDON-CODE
	LED_SMT ?NEWSTATE IF		// Is this state new?
		LEDON					// turn led on.
	THEN
	ALARMTIME @ RTTVAL @ < 		// check the real time timer
	IF
		200 ALARMTIME +!		// set new alarm time
		LEDOFF_STATE LED_SMT CHANGESTATE 	// set initial state 
	THEN
;

: LEDOFF-CODE
	LED_SMT ?NEWSTATE IF		// Is this state new?
		LEDOFF					// turn led off.
	THEN
	ALARMTIME @ RTTVAL @ < 		// check the real time timer
	IF
		40 ALARMTIME +!			// set new alarm time
		LEDON_STATE LED_SMT CHANGESTATE 	// set initial state 			
	THEN
;

// Build table

LED_SMT 	LEDON_STATE 	INSERT_STATE 	LEDON-CODE
LED_SMT 	LEDOFF_STATE 	INSERT_STATE 	LEDOFF-CODE

: FLASHDEMO
	RESETRTT							// set up the real time timer
	RTTVAL @ ALARMTIME !				// set initial alarm time
	LEDOFF_STATE LED_SMT CHANGESTATE 	// set initial state 
	BEGIN 
		LED_SMT RUN_SM 					// run one interation of the state machine
	GETBUTTON UNTIL					// Repeat until button pushed.
;

FLASHDEMO
