// Demo3 - using a state machine in standard FORTH.
// flash led based on real timer - exit on button down
// tested on olimex mt-256
SP!
RUNTIME
EMPTY
HEX
4000 GETMEM DROP

INCLUDE ..\include\IO.FTH
INCLUDE ..\include\RTT.FTH
INCLUDE ..\include\STATE.FTH


: GETBUTTON 			// mt -- buttons ; read mt-246 buttons
	PIO_PDSR @
	1B RSHIFT 1F XOR
;

: RESETRTT							// set up the real time timer
	RTTRSTBIT 20 + RTTMODE !
	BEGIN 
		RTTVAL @ 0= 
	UNTIL
;

DEFINE_STATES

STATEDEF LEDON_STATE
STATEDEF LEDOFF_STATE

DEFINE_STATE_TABLE LED_SMT

// Define local variable and code.

VARIABLE ALARMTIME

: LEDON-CHANGE
	LEDON					// turn led on.
	40 ALARMTIME +!			// set new alarm time
	LEDON_STATE LED_SMT CHANGESTATE 	// set initial state 	
;

: LEDOFF-CHANGE
	LEDOFF					// turn led off.
	200 ALARMTIME +!		// set new alarm time
	LEDOFF_STATE LED_SMT CHANGESTATE 	// set initial state 
;

: LEDON-BODY
		ALARMTIME @ RTTVAL @ < 		// check the real time timer
		IF
			LEDOFF-CHANGE
		THEN
;

: LEDOFF-BODY
	ALARMTIME @ RTTVAL @ < 		// check the real time timer
	IF
		LEDON-CHANGE
	THEN
;

// Build table

LED_SMT 	LEDON_STATE 	INSERT_STATE 	LEDON-BODY
LED_SMT 	LEDOFF_STATE 	INSERT_STATE 	LEDOFF-BODY

: FLASHDEMO
	RESETRTT							// set up the real time timer
	RTTVAL @ ALARMTIME !				// set initial alarm time
	LEDOFF_STATE LED_SMT CHANGESTATE 	// set initial state 
	BEGIN 
		LED_SMT RUN_SM 					// run one interation of the state machine
	GETBUTTON UNTIL					// Repeat until button pushed.
;

FLASHDEMO
