// ECHO ON
." Including STATE.FTH " CR
VARIABLE STATECNT // Used at compile time.
VARIABLE VERBOSE

VERBOSE OFF

: DEFINE_STATES 1 STATECNT ! ;

: STATEDEF STATECNT @ CONSTANT
VERBOSE @ IF 
	PAD TYPE ."  is " STATECNT ? CR 
THEN
 1 STATECNT +!  ;

: DEFINE_STATE_TABLE
	LABEL
	VARPTR @ 2 ALIGN DUP VARPTR !
	, 			// Point to ram storege 
	1 VARPTR @ !		// set initial state to 1
	STATECNT @ BPW * ALLOT
	BPW VARPTR +!
;
  
: INSERT_STATE // TABLE STATE (WORD IN TIB) -- MT
	BPW * + ' SWAP  !
;

: RUN_SM
	DUP @ @ BPW * + @ EXECUTE
;

ALIAS STR_CODE_DEF STATEDEF // Same as STATEDEF
ALIAS DEFINE_CODES DEFINE_STATES // Same as DEFINE_STATES
ALIAS DEFINE_STRING_TABLE DEFINE_STATE_TABLE // Same as DEFINE_STATE_TABLE

: INSERT_STRING // TABLE CODE STRING -- MT
	ROT ROT BPW * + !
;

: GET_CODE_STRING
	DUP @  @ BPW * + @
;
: ."CODE GET_CODE_STRING TYPE ;

: ?NEWSTATE // TABLEADDR -- T/F ; Check state sign bit, return flag and clear sign if it was set.
	@ DUP @	// VARADDR STATE --
	0< IF 
		DUP @ FFFF AND SWAP !
		TRUE
	ELSE 
		DROP FALSE
	THEN
;

ALIAS ?NEWCODE ?NEWSTATE

: CHANGESTATE // STATE TABLEADDR
	SWAP 80000000 OR SWAP @ ! 
;
ALIAS CHANGECODE CHANGESTATE

: CASE_ERROR ." Unknown case " ;

// The table starts with the number of entries.
// next is the address of the default code for when no case matches
// then the body of the table is made of two word pairs - an interger and an execution address

: DEFINE_CASE_TABLE
	LABEL
	0 , // reserve size
	[ ' CASE_ERROR LITERAL ] , // Default default.
;	
	
: INSERTCASE 
	, ' ,

;

: DEFAULTCASE
' SWAP BPW + !
;

: ENDCASE
	DUP 
	HERE SWAP - 8 - [ 2 BPW * LITERAL ] / SWAP !
;

: EXECUTECASE // CASE TABADDR -- MT 
	DUP 					// CASE TABADDR TABADDR --
	ROT OVER @				// TABADDR TABADDR CASE CNT --
		BEGIN				// TABADDR TABADDR CASE CNT --
			DUP 			// TABADDR TABADDR CASE CNT CNT --
		WHILE				// TABADDR TABADDR CASE CNT --
			>R				// TABADDR TABADDR CASE  -- CNT 2 R
			SWAP [ BPW 2 * LITERAL ] + SWAP // TABADDR TABADDR++ CASE
			OVER @ OVER = 	// TABADDR TABADDR CASE  T/F -- COMPARE CASE TO TABLE.
			IF 
				R> DROP DROP BPW + @ SWAP DROP JUMP	// Get vector while dropping unneeded item and jump to code.
			THEN
			R>
			1-
		REPEAT
		// TABADDR TABADDR CASE 0
		DROP DROP DROP BPW + @ JUMP 
;
