
 ECHO OFF
1000 GETMEM DROP
HEX
// ECHO ON
// RELOC.FOR
//   ECHO OFF
FORTH DEFINITIONS
RUNTIME

0 'LFA ARM !

COMPILER
0 'LFA -BR !

RUNTIME 
0 'LFA [CON] !

' ABORT *ABORT ! // Patch abort address

: CONSTANT
	CREATE
	LRPUSH
	[ ' [CON] RLITERAL ]
	BRLNK		// Make a call to [CON] 
	, 			// Store CONSTANT value from top
;

VARPTR 4 + VARPTR !

: VARIABLE
	CREATE
	LRPUSH
	[ ' [VAR] RLITERAL ] 
	BRLNK		// Make a call to [VAR] 
	VARPTR @ 2 ALIGN DUP VARPTR !
	, 			// Rerserve storage space 
	0 VARPTR @ !
	4 VARPTR +!
;

: BYTEVAR
	CREATE
	LRPUSH
	[ ' [VAR] RLITERAL ] 
	BRLNK		// Make a call to [VAR] 
	VARPTR @
	, 			// Rerserve storage space 
	0 VARPTR @ C! // DON'T CLEAR OR YOU OVERWRITE OLD VARS
	1 VARPTR +!
;

: LABEL
	CREATE
	LRPUSH
	[ ' [LAB] RLITERAL ] 
	BRLNK		// Make a call to [LAB] 
;


: IMMEDIATE	// unlike thumb version - This is ANS93 style - can only change the most recently defined header.
	LATEST @ LFA>FFA F_IMMD OVER C@ OR SWAP C!
;

: ALIAS		// Make alias to an existing word.
	2 ALIGNDP HERE CREATE 4 + DUP C@ F_REMT OR SWAP C! // Set remote bit.
	2 ALIGNDP
	' HERE - 1+ ,
;

// : ALIAS		// Make alias to an existing word.
//	2 ALIGNDP HERE CREATE 4 + DUP C@ F_REMT OR SWAP C! // Set remote bit.
// ' ,
// ;

: ( 29 WORD DROP ;
 IMMEDIATE

COMPILER DEFINITIONS
 
: PATCH			// Insert a branch too *NXT at address @ top
	HERE SWAP ( Save DP for later
	DP !		( Move dp to patch address
	SWAP BR		( Apply the patch
	DP !		( Restore dp 
;

: ELSE 
	HERE
	0 ,	( Reserve space and clear it.	
	SWAP HERE SWAP PATCH
; IMMEDIATE

: THEN
	HERE SWAP PATCH
; IMMEDIATE


: REPEAT
	SWAP	( GET "BEGIN" ADDRESS TO TOP
	BR		( MAKE A BRANCH TO IT
	HERE SWAP
	PATCH	( PATCH THE BRANCH AT "" TO HERE
; IMMEDIATE

: EXIT
	PCPOP
; IMMEDIATE

: BEGIN 
	HERE
; IMMEDIATE

: DO 
	[ ' [DO] RLITERAL ]
	BRLNK		// Make a call to [DO]
; IMMEDIATE

: LOOP
	[ ' [LOOP] RLITERAL ]
	BRLNK		// Make a call to [LOOP]
; IMMEDIATE

: IF // -- ADDR ; 
	[ ' [IF] RLITERAL ]
 BRLNK // At compile time compiler a call to [IF]
	HERE 									// Save here for ELSE or THEN to patch.
	0 ,
; IMMEDIATE
FORTH DEFINITIONS

: ERASE // START LEN --
	0 DO
		0 OVER I + C!
	LOOP
	DROP
;

: STRING                	// DELIM -- )
 WORD                    	// PAD -- )
	C@ 1+ 0 DO              // move parsed word to here
		PAD I + C@
		C,
	LOOP
;

: TEXT" 22 STRING 2 ALIGNDP ;
: STRCONSTANT LABEL TEXT" ;

// RAM OFFSET ERASE

: PATCHIT
// CONTEXT- CONTEXT- -- PATCH MOVED CONTEXT 
	BEGIN
	DUP @ 
	0 >
	IF 							// IF DOES THE SAME AS WHILE;	THREAD --
		DUP @ OFFSET - 			// LINKAD LINK- 
		DUP ROT !
	REPEAT	
	DROP
;

: MULTIPATCH
//    PATCHIT
	PATCHIT 
	PATCHIT
	PATCHIT
;	

: PATCHVOC 

	BPW 2 * + 
	      DUP @ @ DUP IF OFFSET - OVER @ .S ! ELSE DROP THEN		// PATCH *THREAD
	BPW + DUP @ OFFSET - OVER !					// PATCH VOCAB LINK
	BPW + DUP @ OFFSET - SWAP !					// PATCH *NAME
;

RUNTIME
  
 0 ' FORTH BPW 3 *  +  !
// ECHO ON
: PATIOABORT
	BLK@ . CR
	BLK@ 4 + CLOSEFP
	BLK 0!
	RP! OP! MP!
	INIT
	OFFSET *PUTLINE -!
	OFFSET *GETLINE -!
	OFFSET *KEY -!	
	OFFSET DP -!
	OFFSET *ABORT -!
	CONFIGURE
	20 [ ' WORD LITERAL ] EXECUTE .S -INCLUDE
 ECHO OFF
QUIT
;

' ARM // REMEMBER THIS 

0 'LFA FORTH !		// Make this the first {lowest} Word in the dictionary.

FORTH RAM OFFSET .S CMOVE

// COMPILER ' LITERAL BPW 2 * + DUP @ OFFSET - SWAP !

' FORTH OFFSET - PATCHVOC
' COMPILER OFFSET - PATCHVOC
' RUNTIME OFFSET - PATCHVOC
OFFSET VOCLINK -!

	COMPILER CONTEXT @ 
	RUNTIME CONTEXT @ 
	FORTH CONTEXT @
	MULTIPATCH
 PATIOABORT EXTRA.FTH
	
