 // ECHO ON
( Creative Commons Attribution-Noncommercial 2.5 License
HEX 
6000 GETMEM DROP 
HERE 206000 < IFDO 206000 DP ! 6000 GETMEM DROP ." FLASH" CR
HERE 4000 .S ERASE
SP!
FORTHONLY
FORTH DEFINITIONS

// INCLUDE PV.FTH

: XCOMP ; // A MARKER
// constants to define different type of hardware
0	CONSTANT GENERIC
1	CONSTANT H256
2	CONSTANT EX256
3	CONSTANT MT256
." Meta-compiling EMforth kernel " CR
// ECHO ON
MT256 CONSTANT PCBTYPE
( EX256 CONSTANT PCBTYPE
( GENERIC CONSTANT PCBTYPE

// ECHO OFF

RUNTIME

// HOST CONSTANTS FOR TARGET COMPILATION.

VARIABLE NEWCODESTART
// F_IMMD DROP
: 'IMMEDIATE	// 
	'LFA LFA>FFA F_IMMD OVER C@ OR SWAP C!
;
// : PATCHDP 10 + DP @ SWAP ! ;
COMPILER

ALIAS HOST." ."
'IMMEDIATE HOST."
ALIAS HOST[ [
'IMMEDIATE HOST[
FORTH
// ALIAS HOSTFORTH FORTH
ALIAS HOST@ @
ALIAS HOSTABORT ABORT
ALIAS HOSTPAD PAD
ALIAS HOSTWORD WORD
ALIAS HOSTBLK BLK
ALIAS HOSTCR CR
ALIAS HOSTBLK@ BLK@ 
ALIAS HOST= = 
ALIAS HOST.S .S
ALIAS HOSTDUMP DUMP
ALIAS HOST+ +
ALIAS HOST- -
ALIAS HOST! !
ALIAS HOSTVLIST VLIST
ALIAS HOST' ' 
ALIAS HOST'LFA 'LFA
ALIAS HOSTHERE HERE 
ALIAS HOST. . 
ALIAS HOST] ] 

ALIAS HOST[LIT] [LIT] 
ALIAS HOSTDEFINITIONS DEFINITIONS 
: HOST2W+ BPW 2 * + ;
ALIAS HOSTBPW BPW 
ALIAS HOSTECHO ECHO 
-4 CONSTANT HOST-BPW
200 CONSTANT HOSTBUFFERSIZE

( NETWORK DEFINITIONS
1 CONSTANT HOSTVDU
2 CONSTANT HOSTKBD
3 CONSTANT HOSTFSERVE

80 CONSTANT TIBSIZE 
80 CONSTANT TOBSIZE
80 CONSTANT PADSIZE
40 CONSTANT VSIZE
40 CONSTANT OSIZE
40 CONSTANT MSIZE
100 CONSTANT DSIZE
// ADD RSIZE
800 CONSTANT VARRAMSIZE

10 CONSTANT   Mode_USR
11 CONSTANT   Mode_FIQ
12 CONSTANT   Mode_IRQ
13 CONSTANT   Mode_SVC
17 CONSTANT   Mode_ABT
1B CONSTANT   Mode_UND
1F CONSTANT   Mode_SYS
80 CONSTANT   I_Bit // when I bit is set, IRQ is disabled */
40 CONSTANT   F_Bit // when F bit is set, FIQ is disabled */
00100000 CONSTANT   FLASHBASE
00200000 CONSTANT   RAMBASE
00210000 CONSTANT   Top_Stack
00000004 CONSTANT   UND_Stack_Size
00000100 CONSTANT   SVC_Stack_Size
00000004 CONSTANT   ABT_Stack_Size
00000004 CONSTANT   FIQ_Stack_Size
00000100 CONSTANT   IRQ_Stack_Size
00000100 CONSTANT   USR_Stack_Size

Top_Stack 
UND_Stack_Size -
SVC_Stack_Size -
ABT_Stack_Size -
FIQ_Stack_Size -
IRQ_Stack_Size -

RUNTIME DEFINITIONS
// ECHO ON 

CONSTANT RSTACK

RSTACK DSIZE - CONSTANT DSTACK
DSTACK OSIZE - CONSTANT OSTACK
OSTACK MSIZE - CONSTANT MSTACK

MSTACK VARRAMSIZE - CONSTANT VARRAM 
// ECHO OFF

// IO Controller definitions
FFFFFF00 	CONSTANT EFC_BASE   	//  .equ    EFC_BASE,       0xFFFFFF00  /* EFC Base Address */
60 			CONSTANT EFC_FMR   		//   .equ    EFC_FMR,        0x60        /* EFC_FMR Offset */
1			CONSTANT EFC_SETUP
00320100   	CONSTANT EFC_FMR_Val   
1 			CONSTANT PMC_SETUP      
00000601 	CONSTANT PMC_MOR_Val
00481C0E 	CONSTANT PMC_PLLR_Val

00000007 	CONSTANT PMC_MCKR_Val 

// Watchdog Timer WDT definitions
FFFFFD40	CONSTANT WDT_BASE				// WDT Base Address */
04    		CONSTANT WDT_MR      			// WDT_MR Offset */
1    		CONSTANT WDT_SETUP      
00008000    CONSTANT WDT_MR_Val
// Power Mangement Controller PMC definitions
FFFFFC00   	CONSTANT  PMC_BASE   	// PMC Base Address */
20    		CONSTANT  PMC_MOR   	// PMC_MOR Offset */
24   	 	CONSTANT  PMC_MCFR   	// PMC_MCFR Offset */
2C   	 	CONSTANT  PMC_PLLR   	// PMC_PLLR Offset */
30    		CONSTANT  PMC_MCKR   	// PMC_MCKR Offset */
68    		CONSTANT  PMC_SR   		// PMC_SR Offset */
1    		CONSTANT  PMC_MOSCEN   		//  1<<0      /* Main Oscillator Enable */
1 1 LSHIFT 	CONSTANT  PMC_OSCBYPASS   	//  1<<1      /* Main Oscillator Bypass */
FF 8 LSHIFT CONSTANT  PMC_OSCOUNT   	//  0xFF<<8   /* Main OScillator Start-up Time */
FF    		CONSTANT  PMC_DIV   		//  0xFF<<0   /* PLL Divider */
3F 8 LSHIFT	CONSTANT  PMC_PLLCOUNT   	//  0x3F<<8   /* PLL Lock Counter */
3  E LSHIFT	CONSTANT  PMC_OUT   		//	0x03<<14  /* PLL Clock Frequency Range */
7FF 10 LSHIFT CONSTANT  PMC_MUL   		//  0x7FF<<16 /* PLL Multiplier */
3 1C LSHIFT	CONSTANT  PMC_USBDIV   		//  0x03<<28  /* USB Clock Divider */
3   		CONSTANT  PMC_CSS    		//  3<<0      /* Clock Source Selection */
7 2  LSHIFT	CONSTANT  PMC_PRES   		//  7<<2      /* Prescaler Selection */
1  			CONSTANT  PMC_MOSCS  		//  1<<0      /* Main Oscillator Stable */
1 2  LSHIFT	CONSTANT  PMC_LOCK 			//  1<<2      /* PLL Lock Status */

FFFFFF00  CONSTANT  MC_BASE			// * MC Base Address */
: RUNARM
 	' 2 ALIGN 1 - EXECUTE
;

: 'SMUDGE // ADDR -- ; Leave addr of smudged char on stack
	'LFA 6 + DUP DUP C@ 80 OR SWAP C!
;

: 'SMUD 'SMUDGE DROP ;


// VARIABLES FOR PATCHING FORWARD REFERENCES 
VARIABLE ADDR[LIT]
VARIABLE ADDR[RLIT]
VARIABLE ADDR[LOOP]
VARIABLE ADDR[DO]
VARIABLE ADDR[VAR]
VARIABLE ADDR[CON]
VARIABLE ADDR[IF]
VARIABLE ADDR[."]
VARIABLE ADDR[ABORT]
VARIABLE ADDR[VOC]
VARIABLE ADDR[LAB]

VARIABLE ADDRSERVCR
VARIABLE ADDRSERVGETLINE

VARIABLE ADDRFORTH
VARIABLE ADDRCOMPILER
VARIABLE ADDRRUNTIME
VARIABLE ADDRASSEMBLER
VARIABLE PATCHLIT
// ECHO ON
: HOST! ! ;

: XLITERAL
	ADDR[LIT] @
	BRLNK		// Make a call to [LIT] 
	, 			// Store literal value from top
;

: XRLITERAL
	ADDR[RLIT] @
	BRLNK		// Make a call to [LIT] 
	HERE BPW+ - , 			// Store literal value from top
;

: X]	COMPILER

// ." X] " CR
	1 MODE ! ( Set mode to compile )
	BEGIN 
	MODE @ 1 =
	WHILE
		BEGIN
			20 WORD	C@
		0= WHILE
			ECHO @ IF 
				CR
			THEN
			GETLINE
		REPEAT
		FIND
		DUP IF ( NOT ZERO 
			DUP 4 + C@ ( GET flags
			F_IMMD AND ( Check immediate flag )
			IF 
				LFA>CA EXECUTE
			ELSE 
			DUP NEWCODESTART @ < 			
				IF .S ." LOWCALL " 
				PAD TYPE CR
				THEN	
			LFA>CA 2 ALIGN BRLNK
			THEN
		ELSE 
			DROP NUMBER	XLITERAL // Don't use this till [lit] is defined.
		THEN 
	REPEAT
;

COMPILER DEFINITIONS

: HOSTABORT" ( Compile ABORT print string.
	22 WORD
	C@ IF
		ADDR[ABORT] @ 2 ALIGN BRLNK (  Make a call to  [abort"] 
		PAD C@ 1 +
		0
		BEGIN				( CNTDWN INDEX --
			DUP PAD + C@ 	( Get byte from PAD )
			C,				( CNTDWN INDEX --
			1 + SWAP
			1 - SWAP
		OVER 0=	UNTIL
		DROP DROP
		2 ALIGNDP
	THEN
;
COMPILER
'SMUD ."

: ." ( Compile print string.
	22 WORD
	C@ IF
		ADDR[."] @ 2 ALIGN BRLNK (  Make a call to  [."] 
		PAD C@ 1 +
		0
		BEGIN				( CNTDWN INDEX --
			DUP PAD + C@ 	( Get byte from PAD )
			C,				( CNTDWN INDEX --
			1 + SWAP
			1 - SWAP
		OVER 0=	UNTIL
		DROP DROP
		2 ALIGNDP
	THEN
;

: DO 
	ADDR[DO] @
	BRLNK		// Make a call to [DO]
;

: LOOP 
	ADDR[LOOP] @
	BRLNK		// Make a call to [LOOP]
;
FORTH DEFINITIONS

ASSEMBLER

// VARRAM 400 + VARPTR !

VARRAM VARPTR !


'SMUD VARIABLE
: VARIABLE
	CREATE
	{ LR } PUSH
	ADDR[VAR] @
	BRLNK		// Make a call to [VAR] 
	VARPTR @ 2 ALIGN DUP VARPTR !
	, 			// Rerserve storage space 
//	0 VARPTR @ ! // DON'T CLEAR OR YOU OVERWRITE OLD VARS
	4 VARPTR +!
;

: BYTEVAR
	CREATE
	{ LR } PUSH
	ADDR[VAR] @
	BRLNK		// Make a call to [VAR] 
	VARPTR @ , 			// Rerserve storage space 
//	0 VARPTR @ ! // DON'T CLEAR OR YOU OVERWRITE OLD VARS
	1 VARPTR +!
;

: CONSTANT
	CREATE
	{ LR } PUSH
	ADDR[CON] @
	BRLNK		// Make a call to [CON] 
	, 			// Store CONSTANT value from top
;

: LABEL
	CREATE
	{ LR } PUSH
	ADDR[LAB] @
	BRLNK		// Make a call to [LAB] 
;

: UNSMUDGE' 
	DUP C@ 7F AND SWAP C!
;

: PATCH			( Insert a branch too HERE at address @ top
	HERE SWAP 	( Save DP for later
	DP !		( Move dp to patch address
	SWAP BR		( Apply the patch
	DP !		( Restore dp )
;

: PATCHVOC		( Insert a branch too HERE at address @ top
	@ BPW + ADDR[VOC] @ SWAP // PATCH [VOC] CALL
	HERE SWAP 	( Save DP for later
	DP !		( Move dp to patch address
	SWAP BRLNK		( Apply the patch
	DP !		( Restore dp )
;

COMPILER DEFINITIONS
: IF // -- ADDR ; 
	ADDR[IF] @ BRLNK // At compile time compiler a call to [IF]
	HERE 									// Save here for ELSE or THEN to patch.
	0 ,
;

: ELSE 
	HERE
	0 ,	( Reserve space and clear it.	
	SWAP HERE SWAP PATCH
;

: THEN
	HERE SWAP PATCH
;

: UNTIL 
	ADDR[IF] @ BRLNK
	BR
;

COMPILER
ALIAS WHILE	IF	//  does the same as IF - note IF isn't immediate yet.

: REPEAT
	SWAP	( GET "BEGIN" ADDRESS TO TOP
	BR		( MAKE A BRANCH TO IT
	HERE SWAP
	PATCH	( PATCH THE BRANCH AT "wHILE" TO HERE
;

: EXIT
{ PC } POP
;
 
COMPILER 

'IMMEDIATE UNTIL
'IMMEDIATE EXIT
'IMMEDIATE ."
'IMMEDIATE IF
'IMMEDIATE ELSE
'IMMEDIATE THEN
'IMMEDIATE WHILE
'IMMEDIATE REPEAT
'IMMEDIATE DO
'IMMEDIATE LOOP
'IMMEDIATE HOSTABORT"

// These are the XCOMP words for colon defs. From this point on we can't do host : defs.

RUNTIME FORTH DEFINITIONS

ALIAS ] X]

: :
// HOST." HOST: " HOSTCR
 	CREATE
 	{ LR } PUSH
 	]
;	
 
 ALIAS HOST: :
 ALIAS HOSTLFA>CA LFA>CA

COMPILER DEFINITIONS

 ALIAS HOST; ;

COMPILER
ALIAS HOSTBRLNK BRLNK 

COMPILER
 'SMUD BRLNK
 'SMUD -BR
 'SMUD BR

'IMMEDIATE HOST;

FORTH DEFINITIONS
HERE NEWCODESTART !
( Next compile XKERN.for ------------------------------------------------------------------------ )
//  ECHO ON
CREATE ARM 
E59FF018 ,	// VECTORS
E59FF018 ,
E59FF018 ,
E59FF018 ,
E59FF018 ,
E59FF018 ,
E59FF018 ,
E59FF018 ,
20 ALLOT // JUMP TABLE
// ECHO ON

'SMUD FORTH
VOCABULARY FORTH
FORTH DEFINITIONS
 'LFA FORTH CONTEXT !
' FORTH ADDRFORTH !

RUNTIME CONTEXT @
'SMUD RUNTIME
FORTH DEFINITIONS
VOCABULARY RUNTIME

RUNTIME CONTEXT !

' RUNTIME ADDRRUNTIME !

// 'LFA FORTH 'LFA RUNTIME !

COMPILER CONTEXT VDROP @

'SMUD COMPILER
FORTH DEFINITIONS
VOCABULARY COMPILER

COMPILER CONTEXT !

' COMPILER ADDRCOMPILER !
 
RUNTIME DEFINITIONS

CODE [CON]		// Like [lit] except we pop the PC 
	4 # RTOP [!] RDSP STR, 	
	LR RTOP LDR,
	{ PC } POP
END-CODE

' [CON] 2 ALIGN ADDR[CON] !

// These are target constants they can NOT! be used by the host!!

200000 CONSTANT RAM 
' ARM 200000 - CONSTANT OFFSET

FFFC0000 	CONSTANT BASE_US0 
FFFC4000 	CONSTANT BASE_US1 	

4			CONSTANT US_MR
14			CONSTANT US_CSR
1C  		CONSTANT US_THR  
18			CONSTANT US_RHR
20			CONSTANT US_BRGR
1 1 LSHIFT	CONSTANT US_TXRDY    //     0x1 <<  1 // DBGU TXRDY Interrup
1 			CONSTANT US_RXRDY    //  

4 CONSTANT BPW

1	CONSTANT F_IMMD		( immediate flag )
2	CONSTANT F_OFFS		( offset compilation flag ie dA non-zero )
4	CONSTANT F_REMT		( remote flag ie headerless code or alias )
8	CONSTANT F_SMUD		( smudge flag )
10	CONSTANT F_VOCB  	( vocab flag )
20 	CONSTANT F_THUMB 

CODE [VAR]		// Like [CON] except we return the address
	4 # RTOP [!] RDSP STR, 	
	LR RTOP LDR,
	{ PC } POP
END-CODE
' [VAR] 2 ALIGN ADDR[VAR] !

// Target variables - not for host!! 

VARIABLE *ABORT
VARIABLE *COLD

FORTH DEFINITIONS

'SMUD DP 
'SMUD CURRENT 
'SMUD LATEST 
'SMUD PAD 
'SMUD MARKER
'SMUD VP
'SMUD MODE
'SMUD VSTACK

VARIABLE DP	// The target dictionary pointer.
VARIABLE CURRENT	// We compile new code here. 

RUNTIME DEFINITIONS

'SMUD VOCLINK
VARIABLE VOCLINK

VARIABLE LATEST
VARIABLE VP          ( vocab stack pointer )
VARIABLE MARKER
// *USART .S @ .S
	VARIABLE *USART 
// *USART .S !

'SMUD *GETLINE
	VARIABLE *GETLINE
'SMUD *PUTLINE
	VARIABLE *PUTLINE
	VARIABLE *KEY
	VARIABLE *HIT

	VARIABLE ERRORVEC
	VARIABLE STRTVEC
	
FORTH DEFINITIONS	
	VARIABLE BLK            ( BLK 0 or points to the file descripter&buffer )
	VARIABLE ECHO
	VARIABLE CNT
	VARIABLE OUTCNT
	VARIABLE CAPFP			( CAPTURE FP 32 BIT )
	VARIABLE STDOUTFP		( stdout FP 32 BIT )
VARIABLE MODE
	VARIABLE BALANCE

VARIABLE >IN	// input charactor pointer
// VARIABLE OUT>	// output charactor pointer
VARIABLE BASE
VARIABLE TIB	// input buffer
TIBSIZE VARALLOT
VARIABLE TOB	// output buffer
TOBSIZE VARALLOT
VARIABLE PAD	// scratch pad 
PADSIZE VARALLOT
VARIABLE VSTACK	// Vocab stack 
VSIZE VARALLOT

CODE [LAB]		// Like [CON] except we return the address
	4 # RTOP [!] RDSP STR, 	
	LR RTOP MOV,
	{ PC } POP
END-CODE
' [LAB] 2 ALIGN ADDR[LAB] .S !
( NETWORK DEFINITIONS
1 CONSTANT VDU
2 CONSTANT KBD
3 CONSTANT FSERVE
ASSEMBLER
// ECHO ON
( ---------------------------------------------------------------------)
LABEL &VDU      ( header info for packets sent to VDU channel)
HOSTVDU
 LLHH
0 2C, ( PORT ie the port or pseudo port on the destination processor )
1 C, ( SIZE ie number of nodes )
1 C, ( CURRENT NODE ie the next node the packet goes through)
													( a no. from 1 to SIZE )
0 C, ( LINKS ie a list of links numbered 0-3 which is SIZE long )
( ---------------------------------------------------------------------)
LABEL  &KBD     ( header info for packets sent to Keyboard channel)
HOSTKBD LLHH 0 2C, ( PORT ie the port or pseudo port on the destination processor )
1 C, ( SIZE ie number of nodes )
1 C, ( CURRENT NODE ie the next node the packet goes through )
												( a no. from 1 to SIZE )
0 C, ( LINKS ie a list of links numbered 0-3 which is SIZE long )
( ---------------------------------------------------------------------)
LABEL &FSERVE    ( header info for packets sent to FileServer channel)
HOSTFSERVE LLHH 0 2C,
1 C, ( SIZE )
1 C, ( CURRENT NODE )
0 C, ( LINKS )
( ---------------------------------------------------------------------)
LABEL  SYNC   ( the sync patern, plus a null reply port )
	A5 C,
	5A C,
	5A C,
	5A C,
	0 2C, 0 2C,
( ---------------------------------------------------------------------)
// Note we can no longer use the host versions of these.
80 CONSTANT TIBSIZE 
80 CONSTANT TOBSIZE
80 CONSTANT PADSIZE
40 CONSTANT VSIZE

RUNTIME DEFINITIONS 

CODE [IF]
	0 # RTOP CMP,	// Test top for zero ie false.
	NE 4 # LR ADD,	// If cc are set to NE skip over the branch 
	-4 # RDSP [P] [!] RTOP LDR, // drop top.
	LR PC MOV,	
END-CODE
' [IF] 2 ALIGN ADDR[IF] !

(  loop runtime code )
CODE [LOOP]             ( R = loopaddr limit count LR = return  )
	{ R0 R1 R2 } [U] LDM,  // NO [!]
	1 # R0 ADD,
	R1 R0 CMP,
	LT IF,					( if limit not reached )
		{ R0 } STM,			// NO [P] OR [!]
		R2 PC MOV,
	THEN,
	0C # SP ADD,			// DROP 3 ITEMS FROM STACKBPW ,X LDY,
	LR PC MOV,
END-CODE
' [LOOP] 2 ALIGN ADDR[LOOP] !

CODE [DO]            	( D = limit count -- mt LR = Loopaddr )
	{ LR } 		PUSH
	-4 # RDSP [P] [!] R5 LDR, // LOAD COUNT.
	{ R5 } 	PUSH
	{ RTOP } PUSH
	-4 # RDSP [P] [!] RTOP LDR,	
//	{ RTOP } [!] [P] RDSP LDM, // Load both top and next 
	LR PC MOV,
END-CODE                ( R = loopaddr limit count -- )

' [DO] 2 ALIGN ADDR[DO] !
'SMUD [LIT]
CODE [LIT]		// get the word at LR to top and advance LR.
	4 # RTOP [!] RDSP STR, 				// str 	r5,[r7]
	4 # [!] LR RTOP LDR,
	LR PC MOV,							//	mov 	pc,lr
END-CODE

' [LIT] 2 ALIGN ADDR[LIT] !

CODE [RLIT]		// get the word at LR to top and advance LR.
	4 # RTOP [!] RDSP STR, 				// str 	r5,[r7]
	4 # [!] LR RTOP LDR,
	LR RTOP RTOP ADD,	
	LR PC MOV,							//	mov 	pc,lr
END-CODE

' [RLIT] 2 ALIGN ADDR[RLIT] !

CODE RESET
// Setup EFC
	LR R5 MOV, 

	EFC_BASE # R0 MOV,      		//    LDR     R0, =EFC_BASE
	EFC_FMR_Val # R1 MOV,  			//    LDR     R1, =EFC_FMR_Val
	R1 EFC_FMR # [P] R0 STR,  		//    STR     R1, [R0, #EFC_FMR]
		
// Setup WDT
    WDT_BASE # R0 MOV,      		//    LDR     R0, =WDT_BASE
    WDT_MR_Val # R1 MOV,    		//    LDR     R1, =WDT_MR_Val
    R1 WDT_MR #  [P] R0 STR,   		//    STR     R1, [R0, #WDT_MR]

// Setup PMC

	PMC_BASE # R0 MOV,     			//    LDR     R0, =PMC_BASE

//  Setup Main Oscillator
   PMC_MOR_Val # R1 MOV,    		//  LDR     R1, =PMC_MOR_Val
   R1 PMC_MOR # R0 [P] STR,      	//  STR     R1, [R0, #PMC_MOR]

//  Wait until Main Oscillator is stablilized

	BEGIN,
		PMC_SR # R0	[P] R2 LDR, 			// LDR     R2, [R0, #PMC_SR]
        PMC_MOSCS # R2 R2 [S] AND,  // ANDS    R2, R2, #PMC_MOSCS
    NE UNTIL, 						// BEQ     MOSCS_Loop

//  Setup the PLL

    PMC_PLLR_Val # R1 MOV,      	//        LDR     R1, =PMC_PLLR_Val
    R1 PMC_PLLR # [P] R0 STR,       //        STR     R1, [R0, #PMC_PLLR]

//  Wait until PLL is stabilized
	BEGIN, 
		PMC_SR # R0 [P] R2 LDR,    	//  LDR     R2, [R0, #PMC_SR]
		PMC_LOCK # R2 R2 [S] AND,   //            ANDS    R2, R2, #PMC_LOCK
    NE UNTIL,						//          BEQ     PLL_Loop

//  Select Clock
    PMC_MCKR_Val # R1 MOV,      	//            LDR     R1, =PMC_MCKR_Val
    R1 PMC_MCKR # [P] R0 STR,     	//            STR     R1, [R0, #PMC_MCKR]

// Setup Stack for each mode

    210000 # R0 MOV,        		// LDR     R0, =Top_Stack
	
//  Enter Undefined Instruction Mode and set its Stack Pointer
    Mode_UND I_Bit F_Bit OR OR # _C CPSR MSR,        	//    MSR     CPSR_c, #Mode_UND|I_Bit|F_Bit
    R0 SP MOV,							        		//    MOV     SP, R0
    UND_Stack_Size # R0 R0 SUB,				        	//    SUB     R0, R0, #UND_Stack_Size

//  Enter Abort Mode and set its Stack Pointer
    Mode_ABT I_Bit F_Bit OR OR # _C CPSR MSR,           //    MSR     CPSR_c, #Mode_ABT|I_Bit|F_Bit
    R0 SP MOV,							        		//    MOV     SP, R0
    ABT_Stack_Size # R0 R0 SUB,				        	//    SUB     R0, R0, #ABT_Stack_Size

//  Enter FIQ Mode and set its Stack Pointer
    Mode_FIQ I_Bit F_Bit OR OR # _C CPSR MSR,           //   MSR     CPSR_c, #Mode_FIQ|I_Bit|F_Bit
    R0 SP MOV,							        		//   MOV     SP, R0
    FIQ_Stack_Size # R0 R0 SUB,				        	//   SUB     R0, R0, #FIQ_Stack_Size

//  Enter IRQ Mode and set its Stack Pointer
    Mode_IRQ I_Bit F_Bit OR OR # _C CPSR MSR,           //   MSR     CPSR_c, #Mode_IRQ|I_Bit|F_Bit
    R0 SP MOV,							        		//    MOV     SP, R0
    IRQ_Stack_Size # R0 R0 SUB,				        	//    SUB     R0, R0, #IRQ_Stack_Size

//  Enter Supervisor Mode and set its Stack Pointer
    Mode_SVC I_Bit F_Bit OR OR # _C CPSR MSR,           //    MSR     CPSR_c, #Mode_SVC|I_Bit|F_Bit
    R0 SP MOV,							        		//    MOV     SP, R0
    SVC_Stack_Size # R0 R0 SUB,				        	//    SUB     R0, R0, #SVC_Stack_Size

//  Enter User Mode and set its Stack Pointer
    Mode_USR # _C CPSR MSR,           					//    MSR     CPSR_c, #Mode_USR
    R0 SP MOV,	
    USR_Stack_Size # R0 R0 SUB,				        	//    SUB     R0, R0, #SVC_Stack_Size

	R0 RDSP MOV,										// DATA STACK

	MC_BASE	# R0 MOV,	
	1 #	R1 MOV,     
	R1 R0 STR,   						        		//    MOV     SP, R0
	R5 PC MOV,
END-CODE

FORTH DEFINITIONS 
RUNTIME

CODE MP!	// PATCH
	MSTACK # RMP MOV, 
	LR PC MOV,
END-CODE

CODE MP@	// 
	4 # RTOP RDSP [!] STR, 
	RMP RTOP MOV,
	LR PC MOV,
END-CODE

CODE OP!	// 
	OSTACK # ROP MOV, // patched after relocation.
	LR PC MOV,
END-CODE

CODE OP@	// 
	4 # RTOP RDSP [!] STR, 
	ROP RTOP MOV,
	LR PC MOV,
END-CODE

CODE RP!	// Must be called from the top level.
	RSTACK # SP MOV, // patched after relocation.
	LR PC MOV,
END-CODE

CODE LR@	// Must be called from the top level.
	4 # RTOP RDSP [!] STR, 
	LR RTOP MOV,
	LR PC MOV,
END-CODE

CODE RP@	// Must be called from the top level.
	4 # RTOP RDSP [!] STR, 
	SP RTOP MOV,
	LR PC MOV,
END-CODE

CODE SP! 
	DSTACK # RDSP MOV,
	LR PC MOV,
END-CODE

CODE SP@
	4 # RTOP RDSP [!] STR, 
//	RTOP RSEC MOV,		
	RDSP RTOP MOV,
	LR PC MOV,		
END-CODE

CODE 0	// Push 0 - Saved 208 bytes.
	RTOP 4 # RDSP [!] STR, 
//	RTOP RSEC MOV,
	00 # RTOP MOV,		// Use 00 not 0 to avoid recursion.
	LR PC MOV,		
END-CODE

CODE 1	// Push 1 - Saved 60 bytes.
	RTOP 4 # RDSP [!] STR, 
//	RTOP RSEC MOV,
	01 # RTOP MOV,		// Use 01 not 1 to avoid recursion.
	LR PC MOV,		
END-CODE

CODE 2	// Push 2 - Saved 64 bytes.
	RTOP 4 # RDSP [!] STR, 
//	RTOP RSEC MOV,
	02 # RTOP MOV,		// Use 02 not 2 to avoid recursion.
	LR PC MOV,		
END-CODE

CODE 4	// Push 4 - Saved 44 bytes.
	RTOP 04 # RDSP [!] STR, // Use 04 not 4 to avoid recursion.
//	RTOP RSEC MOV,
	04 # RTOP MOV,		// Use 04 not 4 to avoid recursion.
	LR PC MOV,		
END-CODE

CODE 8	// Push 8 - Saved 44 bytes.
	RTOP 4 # RDSP [!] STR, 
//	RTOP RSEC MOV,
	08 # RTOP MOV,		// Use 08 not 8 to avoid recursion.
	LR PC MOV,		
END-CODE
	

CODE ?DUP	// duplicate top.
	00 # RTOP CMP,
	04 # RTOP RDSP [!] NE STR, 
	LR PC MOV,		
END-CODE

CODE DUP	// duplicate top.
	04 # RTOP RDSP [!] STR, 
	LR PC MOV,		
END-CODE
CODE DROP	
//	RSEC RTOP MOV,	// drop top.	
	-4 # RDSP [P] [!] RTOP LDR,
	LR PC MOV,		
END-CODE

CODE SWAPDROP	// drop next
//	-4 # RDSP [P] [!] RSEC LDR,
	04 # RDSP SUB,
	LR PC MOV,		
END-CODE

CODE SWAP
//	RTOP R0 MOV,
//	RSEC RTOP MOV,
//	R0 RSEC MOV,
	-4 # RDSP [P] R5 LDR,
	-4 # RTOP [P] RDSP STR,
	R5 RTOP MOV,
	LR PC MOV,		
END-CODE

CODE OVER	
	04 # RTOP RDSP [!] STR, 		// push top
//	RTOP RSEC MOV,					// mov top to next
	-8 # RDSP [P] RTOP LDR, 		// load the orginal next from stack to top - no [!]
	LR PC MOV,		
END-CODE

CODE ROT	
	-8 # RDSP [P] R0 LDR,		// Get 3'rd item
	-4 # RDSP [P] R5 LDR,		// Get 2'rd item
	-4 # RTOP [P] RDSP STR,		// Store top on deep stack.
	-8 # R5 [P] RDSP STR,		// Store r5 sec on deep stack
	R0 RTOP MOV, 	// load the orginal 3'RD from stack to top - no [!]
	LR PC MOV,		
END-CODE

CODE PICK	
	02 # LSL RTOP RDSP RTOP [P] LDR, 		// load from deep stack to top - no [!]
	LR PC MOV,		
END-CODE

CODE 0=
	00 # RTOP CMP,
	EQ IF,
		00 # RTOP MVN,
	ELSE,
		00 # RTOP MOV,
	THEN,
	LR PC MOV,
END-CODE

CODE 0<
	00 # RTOP CMP,
	MI IF,
		00 # RTOP MVN,
	ELSE,
		00 # RTOP MOV,
	THEN,
	LR PC MOV,
END-CODE

CODE = 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP R5 RTOP [S] SUB,
	EQ IF,
		00 # RTOP MVN,
	ELSE,
		00 # RTOP MOV,
	THEN,
	LR PC MOV,
END-CODE

CODE < 
	-4 # RDSP [P] [!] R0 LDR,		// Get 2'rd item
	RTOP R0 RTOP [S] SUB,
	LT IF,
		00 # RTOP MVN,
	ELSE,
		00 # RTOP MOV,
	THEN,
	LR PC MOV,
END-CODE

CODE > 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP R5 RTOP [S] SUB,
	GT IF,
		00 # RTOP MVN,
	ELSE,
		00 # RTOP MOV,
	THEN,
	LR PC MOV,
END-CODE

CODE - 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP R5 RTOP SUB,
	LR PC MOV,
END-CODE

CODE + 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP R5 RTOP ADD,
	LR PC MOV,
END-CODE

CODE 1+ 
	01 # RTOP ADD,
	LR PC MOV,
END-CODE

CODE 1- 
	1 # RTOP SUB,
	LR PC MOV,
END-CODE

CODE AND 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	R5 RTOP RTOP AND,
	LR PC MOV,
END-CODE
 
CODE OR 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	R5 RTOP RTOP ORR,
	LR PC MOV,
END-CODE

CODE XOR 
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	R5 RTOP RTOP EOR,
	LR PC MOV,
END-CODE

CODE *
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	R5 RTOP RTOP MUL,
	LR PC MOV,
END-CODE	

CODE LSHIFT
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP LSL R5 RTOP MOV,
	LR PC MOV,
END-CODE	

CODE RSHIFT
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	RTOP LSR R5 RTOP MOV,
	LR PC MOV,
END-CODE	

CODE 2* 
	RTOP 1 # LSL RTOP MOV,
	LR PC MOV,
END-CODE

CODE 2/ 
	RTOP 1 # LSR RTOP MOV,
	LR PC MOV,
END-CODE

CODE NEGATE 
	0 # RTOP RTOP RSB,
	LR PC MOV,
END-CODE

CODE INVERT 
	RTOP RTOP MVN,
	LR PC MOV,
END-CODE
'SMUD !
CODE !
	-4 # RDSP [P] [!] R0 LDR,		// Get 2'rd item
	R0 RTOP STR,
	-4 # RDSP [P] [!] RTOP LDR,		// Get NEW TOP
	LR PC MOV,
END-CODE

'SMUD C!
CODE C!
	-4 # RDSP [P] [!] R5 LDR,		// Get 2'rd item
	R5 RTOP STRB,
	-4 # RDSP [P] [!] RTOP LDR,		// Get new top

//	{ RTOP RSEC } [!] [P] RDSP LDM, // Load both top and next 
	LR PC MOV,
END-CODE
'SMUD @
CODE @
	RTOP RTOP LDR,
	LR PC MOV,
END-CODE
'SMUD C@
CODE C@
	RTOP RTOP LDRB,
	LR PC MOV,
END-CODE

CODE LINK@
	RTOP R0 LDR,
	1 # R0 R1 [S] AND, // R1 NEVER USED
	EQ IF,
		RTOP RTOP LDR,
	ELSE,
		1 # R0 R0 SUB,
		R0 RTOP RTOP ADD,
	THEN,
	LR PC MOV,
END-CODE

'SMUD >R
CODE >R								// Move top the Rstack
	{ RTOP } PUSH
	-4 # RDSP [P] [!] RTOP LDR,
	LR PC MOV,
END-CODE
'SMUD R>
CODE R>								// Move Top of Rstack to Dstack
	4 # RTOP RDSP [!] STR, 
	{ RTOP } POP
	LR PC MOV,
END-CODE

CODE I								// COPY Top of Rstack to Dstack
	4 # RTOP RDSP [!] STR, 
	{ RTOP } [U] LDM, // NO [!]
	LR PC MOV,
END-CODE

CODE EXECUTE
	RTOP R0 MOV,
	-4 # RDSP [P] [!] RTOP LDR,
	R0 PC MOV,	// Note the calling address is still in LR and will be used by the word we execute
END-CODE

CODE JUMP		// Don't use this to exit a loop
	RTOP R0 MOV,
	-4 # RDSP [P] [!] RTOP LDR,
//	4 # SP [!] LR LDR,			// Drop calling address from LR so return is one level up.
	{ LR } POP
	R0 PC MOV,	
END-CODE

'SMUD U/MOD
CODE U/MOD	( A B --> A umod B, A/B )
	-4 # [P] RDSP R5 LDR,
	R5 R0 MOV,
	RTOP R2 MOV,
	1 # R3	MOV,			//  MOV      R3,#1     ;set bit 0 in R3, which will be shifted left then right
	1 # LSR R5 R5 MOV,
	BEGIN,					// .start
		R5 R2 CMP,			// CMP      R2,R1
		1 # LSR R5 R5 LS MOV,	//	MOVLS    
		1 # LSL RTOP RTOP LS MOV,	//	MOVLS    R2,R2,LSL#1
		1 # LSL R3 R3 LS MOV,		//	MOVLS    R3,R3,LSL#1
	HI UNTIL,					// BLS      start
	R0 R5 MOV,
	00 # R0	MOV,			//	MOV      R0,#0     ;clear R0 to accumulate result
	BEGIN,						// .next
		RTOP R5 CMP,				// CMP       R1,R2      	;carry set if R1>R2 (don't ask why)
		RTOP R5 R5 CS SUB,			// SUBCS     R1,R1,R2   	;subtract R2 from R1 if this would give a positive answer
		R3 R0 R0 CS ADD,			// ADDCS     R0,R0,R3   	;and add the current bit in R3 to the accumulating answer in R0
		01 # LSR R3 R3 [S] MOV,		// MOVS      R3,R3,LSR#1     ;Shift R3 right into carry flag
		01 # LSR RTOP RTOP  CC MOV,	// MOVCC     R2,R2,LSR#1     ;and if bit 0 of R3 was zero, also shift R2 right
	CS UNTIL,						// BCC       next ;If carry not clear, R3 has shifted back to where it started, and we can end
	R0 RTOP MOV,	
	-4 # [P] R5 RDSP STR,	
	LR PC MOV,
END-CODE

: LINK! ( VAL LINKADDR -- )
	SWAP OVER - 1 OR
	SWAP !
;

// HOSTECHO OFF
 PCBTYPE H256 HOST= IFDO INCLUDE H256.DEF
 PCBTYPE EX256 HOST= IFDO INCLUDE EX256.DEF
 PCBTYPE GENERIC HOST= IFDO INCLUDE GENERIC.DEF
 PCBTYPE MT256 HOST= IFDO INCLUDE MT256.DEF
 
  LEDBIT 	PIO_PER 	!
  INITOER 	PIO_OER		!
  INITOER-B PIO_OER-B	!	
  
// HOSTECHO ON
: ON 1 SWAP ! ;
: OFF 0 SWAP ! ;

'SMUD CONTEXT
: CONTEXT VP @ BPW - @ @ ;
'SMUD VP!

: VP!
	VSTACK VP !
;

'SMUD FORTHONLY
: FORTHONLY		( ONLY SEARCH FORTH VOCAB )
	VP! FORTH
;

: / 							// Make number positive before sending to u/mod then adjust sign of result. 
	DUP 0 < IF
		NEGATE 1 >R 
	ELSE
		0 >R
	THEN
	SWAP
	DUP 0 < IF
		NEGATE R> 1 XOR >R 
	THEN
	SWAP
	U/MOD
	SWAPDROP
	R> IF NEGATE THEN	// Get sign flag from R and adjust result as needed.
; 
	
: U/ U/MOD SWAPDROP ;
: UMOD U/MOD DROP ;

'SMUD ALIGN
: ALIGN 			// Align address on stack 
	1 				( Build mask etc. -- N 1
	BEGIN
		SWAP 2 *
		SWAP 1 -
		DUP 
	0=	UNTIL
	DROP 		// ADDR MASK -- 
	SWAP OVER 1 - +	// MASK {ADDR+MASK-1} -- 
	SWAP NEGATE AND 
;

'SMUD ,
: ,	
	DP @ 2 ALIGN SWAP  //  AHERE VAL --
	OVER			 // AHERE VAL AHERE --
	! 4 + DP !
;
'SMUD C,
: C,	
	DP @ SWAP OVER C! 1 + DP !
;

: +!
	SWAP OVER @ //  VAR NUM *VAR
	+ SWAP ! 
;
: C+!
	SWAP OVER C@ //  VAR NUM *VAR
	+ SWAP C! 
;

: -!
	SWAP OVER @ //  VAR NUM *VAR
	SWAP - SWAP ! 
;

: SOUT 
	BEGIN
		*USART @ US_CSR + @
		US_TXRDY AND 
	UNTIL
	*USART @ US_THR + C!
;

:	RXRDY?  *USART @ US_CSR + @	US_RXRDY AND
;

: TSIN // TIMED SIN TO- NUM=TIME, -1 = FOREVER / TO -- CHAR/FALSE 
	BEGIN
		RXRDY? 
		IF DROP *USART @ US_RHR + C@ EXIT THEN // Return char
	DUP 0 < IF DROP -1 THEN // If count negative don't let it dec.
	1- DUP
	-1 = UNTIL
;

: SIN 
	-1 TSIN
;


: OUT! OUTCNT OFF ;

: EMIT // CHAR -- ; TOP TO TOB.
  	OUTCNT @ 			// CHAR @OUTCNT -- ;
	DUP TOBSIZE < 	// CHAR @OUTCNT flag-- ;
	IF 				// CHAR @OUTCNT -- ;
	SWAP OVER 	// @OUTCNT CHAR @OUTCNT -- ;		
		TOB + C! 	// @OUTCNT --
		1 + OUTCNT  !
	ELSE			// CHAR @OUTCNT -- ;
		DROP DROP
	THEN
;

-1 CONSTANT TRUE
// ALIAS FALSE 0
: FALSE 0 ;
ALIAS WRITEC SOUT

RUNTIME DEFINITIONS
'SMUD [."]

: TYPE							// addr -- 
	DUP C@						// addr cnt -- GET COUNT
	BEGIN
		DUP
	WHILE						// while cnt not zero
		1 - 					// addr cnt-1 -- 
		SWAP 1 + DUP C@ EMIT	// cnt-1 addr+1 -- 
		SWAP					// addr+1 cnt-1 -- 
	REPEAT
	DROP DROP
;

: [."]
	I TYPE 
	R> DUP C@ + 1+ 2 ALIGN >R
;

' [."] ADDR[."] HOST! // NO 2 ALIGN - this is done by ."
FORTH DEFINITIONS
: SPACE 20 EMIT ;
: SPACES DUP 0 > IF 0 DO SPACE LOOP ELSE DROP THEN ;

: [SENDTOB]
	OUTCNT @ 			( no chars to send )
	TOB        		( address of tob )
	BEGIN
		OVER 
	WHILE
		DUP C@ SOUT
		1+
		SWAP 1- 
		SWAP
	REPEAT
	DROP DROP
;
// 100 ALLOT
: DUMBCR
	0D EMIT
	0A EMIT
	[SENDTOB]
	OUT!
;

RUNTIME FORTH

// HOSTECHO ON
: CR *PUTLINE @ EXECUTE ;
'SMUD DELAY

: DELAY 
	40000 0 DO LOOP 
;

: FLASHLED
 	LEDON	
	DELAY
	LEDOFF
	DELAY
;

: ABS	( N - U ) DUP 0 < IF NEGATE THEN ;

: HOLD	( ..# X N - ..# X)
	SWAP >R SWAP 1 + R>
;

: DIGIT	 ( N - N)
	DUP 9 > IF 7 + THEN 30 + // 30 HEX 
;

: <#	 ( N - ..* N)
	-1 SWAP
;

: #>	 ( ..# N)
	DROP -1 DO 
	EMIT LOOP ;

: #		 ( ..# N - ..# N)
	BASE @ U/MOD SWAP 
	DIGIT HOLD ;

: #S	 ( ..# N - ..# 0)
	BEGIN
		# DUP
	0= UNTIL
;

: SIGN	( ..# N N - ..# N )	0 < IF 2D HOLD THEN ;

: (.)	 ( N - ..# N)

	DUP >R ABS <# #S R> SIGN
;

FORTH DEFINITIONS
RUNTIME
: . ( N)
	(.) #> SPACE
;

: U.R	( U N) >R <# #S OVER R> SWAP - SPACES #> ;

: U.	( U) 0 U.R SPACE ;

: U?	( A) @ U. ;

: ?	( A) @ . ;
// HOSTECHO ON

: LINK? 
	LINK@ U.
;


DSTACK 
'SMUD DSTACK
CONSTANT DSTACK
MSTACK 
'SMUD MSTACK
CONSTANT MSTACK

VARRAM BPW- HOST.S CONSTANT FREETOP 

// HOSTECHO OFF
: DEPTH
	SP@ DSTACK - 4 / 1 -                  ( bpw / ? )
;

: .S
	DEPTH 		( depth --- )
	CR 
	." DATA STACK -- "
	DUP 0 < IF ." UNDERFLOWED!! " 7 EMIT
	ELSE
		BEGIN 		( depth --- )
			DUP      ( depth depth --- )
		WHILE       ( depth ---
			DUP 1+ PICK U. ( depth data -- )
			1-      ( depth-1 --- )
		REPEAT
		DROP
		." [TOS] " 
    THEN
	CR
;

: NOT 0= ; // Make this an alias?? Not before the reloction or you have to patch it again.

: CHK>IN 	// RANGE CHECK >IN
	>IN @ TIBSIZE <
;

: >TIB		// CHAR -- ; Save char to TIB
	CHK>IN 
	IF
		TIB >IN @ + C!
		1 >IN +!	// -- save the char
	ELSE
		DROP
	THEN
;

: DEC>IN	// -- dec >in
	1 >IN -!
;

: DECIMAL A BASE ! ;

: HEX 10 BASE ! ;

: DOCHAR
		DUP 8 = 			// CHAR FLAG -- Was  char a backspace
		IF DROP				// -- yes drop the char
			>IN @			// @>IN  -- are there any chars in the buffer
			IF 				// -- yes
				DEC>IN		// -- dec >in
			THEN			// -- 
		ELSE				// CHAR -- not a BS
			DUP 9 = 		// CHAR -- is it a tab
			IF					
				DROP 20 	// SPACE  -- convert tab to space
			THEN
			>TIB 			// -- save char
		THEN
;

: GETSERLN
	0 >IN !	// use >IN for overflow checking
	BEGIN					//  -- 
		SIN					// CHAR -- 
		DUP D = NOT			// CHAR FLAG -- ; True if not CR
	WHILE					// CHAR -- 
		DOCHAR
	REPEAT
	DROP D >TIB				// -- save a CR char
	0 >IN !
;

// ' GETSERLN ' *GETLINE HOST2W+ HOST!
// ' GETSERLN *GETLINE HOST!

: GETLINE *GETLINE @ EXECUTE ;

: TIB>
	TIB >IN @ + C@
	1 >IN +!
;

RUNTIME
'SMUD WORD
: WORD // delim -- pad
	0 PAD C!					// delim -- Zero pad count
	PAD 						// delim pad  --
	BEGIN						// Skip leading delim
		OVER TIB> =				// delim pad flag -- true if char = delim
		CHK>IN 	AND				// delim pad flag  flag  -- true if >IN not overflowed and previous test is true
	NOT UNTIL					// loop back until either test = false
	DEC>IN						// delim pad -- step >in back one char
	BEGIN						// scan to delim or control char
		1 +						// delim pad+  --
		OVER TIB> SWAP OVER = NOT	// delim pad+ char flag -- true if char is not a delimiter
		OVER 1F > AND			// delim pad+ char flag -- true if  char is not delim and not a control char such as CR or null
		CHK>IN AND				// delim pad+ char flag -- true if if both tests are true and >in hasn't overflowed.
	WHILE						// while all three tests are true do the while part.
		OVER C!					// delim pad+ -- 
		1 PAD C+!				// delim pad+ -- Inc cnt
	REPEAT
	ROT = NOT IF DEC>IN THEN 	// Pad+ - If char is not delim then step back one   
	DROP						// -- drop pad+ 
	PAD
;


: BPW+ BPW + ;
: BPW- BPW - ;

: ID	( LFA --> )
	BPW+						( FFA --> )
	DUP C@ 
	F_REMT AND
		IF ." ^ "
		ELSE
			DUP C@ F_SMUD AND
				IF ." * "
				ELSE
				DUP C@ F_VOCB AND
					IF ." V "
					ELSE 2 SPACES
					THEN
				THEN
		THEN
	1+ DUP C@ 						( NFA COUNT --> )
	DUP 8 > IF DROP 8 THEN			( ONLY DO 8 CHARs )
	SWAP 1+ OVER					( COUNT NFA+1 COUNT --> )
		0 DO
			DUP I + C@  EMIT
		LOOP
	DROP SPACE						( COUNT --> )
	DUP 9 < IF
		8 SWAP - SPACES
	ELSE
	DROP
	THEN
;

( vocab layout )
(     ???? ,  4 BYTES ,  4 BYTES   , 4 BYTES , 4 BYTES   , 4 BYTES )
( ... NAME , PUSH LR  , [VOC] JSR, , *THREAD , VOCABLINK , *NAME   )
( V1.44 *THREAD is indirect pointing to RAM )
: [VOC]	// Vocab runtime code
	VP	@ // check for dup copy of vocab.
	BEGIN
			BPW -			// Dec VPtr
			DUP				// dup vptr
			VSTACK < 		// vstack underflow?
			OVER @ I = 		// voc not found ?
			OR				// both true 
	UNTIL
	DUP
	VSTACK <
	IF
		DROP
	ELSE					// a copy of the vocab exists. move stack down and overwrite it.
		VP @ SWAP			// VPFREE DUPADDR
		BEGIN
			DUP BPW +
			@ 				// VPFREE DUPADDR HIGHERVOC
			OVER !			// VPFREE DUPADDR
			BPW +			// VPFREE DUPADDR++
			OVER OVER =
		UNTIL
		DROP DROP
		BPW VP -!
	THEN
	R> 
	VP @ !
	BPW VP +!	
;

' [VOC] ADDR[VOC] HOST!
 : KEY *KEY @ EXECUTE ;
 : KEYHIT *HIT @ EXECUTE ;
: VLIST
	CR
	CONTEXT LINK@ 
		 ( FIRST LFA --> )
		0 SWAP							( CNT LFA	--> )
		BEGIN
			DUP
//			0= NOT
//			KEYHIT IF
//				KEY 1B = IF
//					DROP FALSE
//					ELSE
//					KEY DROP
//				THEN
//			THEN
		WHILE
			DUP 4 U.R SPACE DUP ID	( CNT LFA --> )
			SWAP 1+						( LFA CNT++ --> )
				DUP 4 = IF				( LFA CNT FLAG --> )
					CR DROP 0			( LFA 0 --> )
				THEN
				SWAP					( CNT LFA --> )
			LINK@							( CNT NEXTLINK --> )
		REPEAT
		DROP
		DROP
		CR
;

: .V
	CR ." Search order --> " CR
	VP @ 
		BEGIN
			BPW -
			DUP
			VSTACK < NOT
		WHILE
			DUP
			@ [ HOSTBPW 2 * XLITERAL ] + @ 	( CNTADDR  --> )
			TYPE CR
		REPEAT
		DROP
;

: VDROP		( DROP TO OF VOCAB STACK )
	VP @ VSTACK
	< NOT
	IF
		BPW VP -!
	THEN
;
'SMUD HERE
: HERE DP @ ;
: BLK@ BLK @ ;
RUNTIME DEFINITIONS
: [ABORT]
	R> TYPE CR
	BLK@ IF						( if source was disk )
		." Abort in File - "
		BLK@ [ HOSTBUFFERSIZE 18 HOST+ XLITERAL ] +
		TYPE  ." at line "
		BASE @ >R DECIMAL
		BLK@ 10 + U?  ( @ U. )
		R> BASE ! CR
		0 BLK !
	THEN
	CNT @ 1 - 0 DO TIB I + C@ EMIT LOOP CR
	>IN @ PAD C@ - 1 - SPACES PAD C@ 0 DO ." ^" LOOP CR
	*ABORT @ EXECUTE
;
HOST' [ABORT] ADDR[ABORT] HOST!

'SMUD ALIGNDP
: ALIGNDP
	HERE SWAP ALIGN DP !
;

COMPILER DEFINITIONS
// 'SMUD -BR
: -BR							// CODE -- ; a simple version of BR24
	SWAP
	HERE 8 + - 2/ 2/		// CODE SHIFTADDR --
	FFFFFF AND +
	,							// MT -- 
;
// COMPILER 'SMUD BRLNK
: BRLNK EB000000 -BR ;			// CODE ADDR -- To be superseded by version with CCs .


// COMPILER 'SMUD ABORT"

: ABORT" ( Compile ABORT print string.
	22 WORD
	C@ IF
		[ HOST' [ABORT] XRLITERAL ] BRLNK (  Make a call to  [abort"] 
		PAD C@ 1 +
		0
		BEGIN				( CNTDWN INDEX --
			DUP PAD + C@ 	( Get byte from PAD )
			C,				( CNTDWN INDEX --
			1 + SWAP
			1 - SWAP
		OVER 0=	UNTIL
		DROP DROP
		2 ALIGNDP
	THEN
;
COMPILER 'IMMEDIATE ABORT"

RUNTIME DEFINITIONS
// COMPILER 'SMUD CRASH

 : CRASH HOSTABORT" ??? " ;

RUNTIME DEFINITIONS
'SMUD -DIGIT
: -DIGIT	 ( ASCII - N )
	DUP 39 >
		IF
			DUP 40 >
			IF 7 -
			ELSE   CRASH
			THEN
		THEN
	30 - DUP
	BASE @ < OVER 0 < NOT AND
	NOT IF CRASH // HOSTABORT" ??? "
	THEN
;

'SMUD 10*+
: 10*+	 ( U ASCII - U)
	-DIGIT				( CONVERT ASCII TO NUMBER )
	SWAP				( BRING SUM TO TOP )
	BASE @ * +			( * SUM BY BASE AND ADD NUMBER )
;

// HEADS

RUNTIME FORTH DEFINITIONS
: NUMBER	( - N )
	PAD DUP
	1+ C@							( A 1ST --> GET FIRST CHAR )
	DUP 2D	=						( IS IT - )
		IF
			SWAP 0					( SIGN A SUM --> )
		ELSE
			>R 0 SWAP R> -DIGIT		( 0 A SUM --> )
		THEN

	SWAP DUP C@ 1- >R				( SGN SUM A --> REMAINING COUNT TO R )
	1+								( SGN SUM A --> ADDRESS OF NEXT CHAR )
		BEGIN
			I						( GET CNT FROM R )
		WHILE
			1+ SWAP OVER C@			( SGN A++ SUM ASCII --> )
			10*+ SWAP				( SGN SUM A -- )
			R> 1- >R				( SGN SUM A -- DEC CNT )
		REPEAT
	R> DROP							( DROP CNT )
	DROP SWAP						( SUM SGN --> TRASH A GET SIGN )
	IF								( SIGNED )
		0 SWAP -					( -SUM --> )
	THEN
;

'SMUD FIND
: FIND						// -- false/addr
	VP @ 
	BEGIN
			BPW -
			DUP
			VSTACK < NOT
	WHILE
 DUP @ 
	 BEGIN 
	LINK@ 					// LFA -- @ it to get the address of the first word
	 DUP WHILE				// LFA -- check for zero - ie end of list
		DUP 5 +	DUP C@			// LFA DICSTRADDR DScnt -- advance to dict word Cstring and get count byte
		PAD C@ 				// LFA DICSTRADDR DScnt PadCnt -- now compare PAD cnt with word cnt.
		= IF 				// LFA DICSTRADDR -- Size matches compare string	
			PAD DUP C@		// LFA DICSTRADDR PAD PADCNT -- Get pad and cnt  - NB it would be quicker to pick pad from the stack.
			BEGIN
				DUP 0= IF 	// LFA DICSTRADDR PAD PADCNT -- We have a match, quietly slip away with the loot, no-one will notice.
					DROP DROP DROP
					SWAP DROP
					EXIT
				THEN
				1- 					// LFA DICSTRADDR PAD PADCNT -- Dec counter 
				ROT 1+				// LFA PAD PADCNT DICSTRADDR+ -- dic word pointer to top and inced.
				ROT 1+				// LFA PADCNT DICSTRADDR+ PAD+ -- pad pointer to top and inced.
				OVER C@ OVER C@	= 	// LFA PADCNT DICSTRADDR+ PAD+ flag -- compare two chars
				>R ROT R>			// LFA  DICSTRADDR+ PAD+ PADCNT flag -- temp move flag to R so we can bring CNT up again.
			NOT UNTIL				// LFA  DICSTRADDR+ PAD+ PADCNT -- if equal go around the loop.
			DROP DROP DROP			// LFA  -- words didn't match try next one.
		ELSE DROP
		THEN						// LFA -- No match try again

	 REPEAT							// FALSE --
	DROP 
	REPEAT
	DROP 0
;	
'SMUD LFA>CA
: LFA>CA // LFA -- CA ; Make code address from link address
	4 + // REMEMBER FLAG ADDR
	DUP 1 + DUP C@ + 1+ 2 ALIGN
	SWAP 
	C@ F_REMT AND	// Is remote flag set
		IF 
			LINK@		// get remote address
		THEN
;
'SMUD '
: 'LFA
	20 WORD C@ 
	IF FIND
		DUP 0= IF HOSTABORT" ??? " THEN
	ELSE HOSTABORT" ??? "
	THEN
;

: ' 'LFA LFA>CA ;


'SMUD LFA>FFA
: LFA>FFA // Convert the link address to flag address
	4 + 
;

ALIAS 0! OFF 

: CMOVE // SRC DST LEN --
	0 DO  // SRC DST --
		OVER I + C@ OVER I + C!
	LOOP
	DROP
    DROP
;
VARIABLE USER
BPW 3 * VARALLOT
( *********************************************************************** )
( the packet format is as follows )
( SYNC 	REPLY 	DEST 	SIZE 	CURRENTNODE 	LINKS .. )
( 32	   32	      32	   8	   8	            8... 	)
( SIZE2	MESS1	MESS2..	SIZE3	DATA ........ )
( 8	    16	    16	32	    ?????? )
( where SYNC is the pattern A55A5A5A )
( REPLY is the port [if any] in the sending processor where a reply )
(      packet is expected )
( DEST is a port in the destination processor of the process that will )
(      recieve it )
( SIZE is number of nodes )
( CURRENTNODE is the next node the packet goes through a no. from 1 to SIZE )
( LINKS is an array of links numbered 0-3 which is SIZE long )
(     the intial value of CURRENTNODE and the  order of links )
(     hasn't been decided yet; most likely CM will initially = SIZE )
(     and decrement as the packet passes each node and decrementing to zero )
(     indicates the packet has arrived; therefor the LINKS will be in )
(     reverse order ie the last link in the array will be the first used. )
(		If the routers replace the 'current' link with the 'return' link )
(     then destination process can reverse the links to make the return path )

( SIZE2 is the number of messages in the message list )
( MESS1 etc an array of 16 bit message tokens as define by GMESSAGE )
( SIZE3 the length of the DATA field in bytes , is zero if no data )
( DATA the data field if present is an array of bytes of SIZE3 length )
( 16 and 32 bits data are sent low byte first )

: SINTO
	10000 TSIN
;

: SENDSYNC ( SEND SYNC + 4 NULLS )
	  SYNC 8
	  BEGIN
		SWAP DUP C@ SOUT 1+
		SWAP 1- DUP
	  0= UNTIL
	  DROP
	  DROP
;
	  
: DISCARD_PATH
	8 0 DO SINTO DROP LOOP SINTO 	( dump 8 bytes 9'th is path length )
	1+  						( add 1 to path len get no. of chars to discard )
	0 DO SINTO DROP LOOP
;

: READ2C         ( get two bytes from serial port to TOP was D )
	SINTO SINTO 8 LSHIFT +
;

: READ4C        ( get four bytes from serial to TOP - was D and X , X = low16 )
	0
	4 0 DO
		8 RSHIFT SINTO 18 LSHIFT +
	LOOP
;

: GETSYNC // TIMEOUT -- T/F  , TO = -1 = FOREVER   ( Find sync )
	0
	BEGIN
		OVER TSIN
		DUP 0 < IF DROP DROP DROP FALSE EXIT THEN // Timed out RETURN -1
		OVER SYNC + C@ = ( Compare read byte with sync table )
		IF 1+
		ELSE
			DROP 0  
		THEN
		DUP 4 = 
	UNTIL
	SWAP DROP
;

VARIABLE MESSAGE1
VARIABLE DATASIZE
VARIABLE MSGLENGTH

: GET_MSGLST      ( get zero or one messge to memory )
	SINTO    ( get msg length )
	DUP -1 = IF
		DROP 0
	THEN
	DUP MSGLENGTH !
	IF
		READ2C   ( get msg to d )
		MESSAGE1 !
	THEN
;

: GET_DATASIZE
	READ4C
	DATASIZE !
;

: GETACK // Return : T/F
	GETSYNC     ( WAIT FOR SYNC )
	NOT IF FALSE EXIT THEN
	DISCARD_PATH
	GET_MSGLST
	GET_DATASIZE
	TRUE
;

: GETACKTO 
	10000 GETACK
;

: GETACKTODROP GETACKTO DROP ;

: HEADER ( PATH ADDRESS on top )
	SENDSYNC
	7 0 DO 
		DUP I + C@ WRITEC
	LOOP
	DROP
;

: WRITE2C
	DUP FF AND WRITEC
	8 RSHIFT WRITEC
;

: WRITE4C      ( WRITE 4 BYTES LOW IN X HI IN D )
	4 0 DO
		DUP FF AND WRITEC
		8 RSHIFT
	LOOP
	DROP
;

MESSAGES

// : KEY *KEY @ EXECUTE ;

: SERVKEY	( -- CHAR )
	&KBD HEADER
	1 WRITEC
	[ key M> XLITERAL ] WRITE2C
	0 WRITE4C
	GETACKTODROP
	SINTO ( get key )
;

: SERVKEYHIT	( -- CHAR )
	&KBD HEADER
	1 WRITEC
	[ hit M> XLITERAL ] WRITE2C
	0 WRITE4C
	GETACKTODROP
	SINTO ( get key )
;

FORTH DEFINITIONS
	VARIABLE SIZE			( keeps count of storage needed for data )
	VARIABLE PATHSIZE
	VARIABLE SELF			( POINT TO CURRENT CLASS )
( ." Including MEMALLOC.FOR" CR
( LINK LIST USAGE FOR FREE MEMORY LIST
(
( MEMLINK		BLOCK1		BLOCK2		LASTBLK
( FREEPTR	--> FREEPTR	--> FREEPTR	--> ZERO
( SIZE BLK1		SIZE BLK2	SIZELAST		???

	VARIABLE MEMLINK
	HOSTBPW VARALLOT
	VARIABLE TOP
	VARIABLE BOTTOM
	VARIABLE PREV_LINK
	VARIABLE PREV_BLK

: CONFIGURE   ( create linked list of two blocks )
			
	0 HERE !
	HERE MEMLINK !
	FREETOP HERE - BPW-
	MEMLINK BPW+ !

;

: SHOWFREE
		CR
		MEMLINK                      		( MEM MEMLINK )
		BEGIN
			DUP @ 0= NOT
		WHILE
			." Address - " DUP @ U. SPACE
			." Size - " DUP BPW+ @ U. CR
		@                                ( NEW-MEMLINK -- )
		REPEAT
		DROP
;

( GETMEM :- search free list for a large enough block of memory )
( link around it and return address of the first free byte )
( the size of the block is store in the word before this location )
( if cutting a block the reqested size would leave a fragment that's )
( too small to keep the link + size then the block that's returned to )
( the user is padded out to avoid this , since the actual block size is )
( stored in free-bpw this isn't a problem when freeing a block )
// HEADERLESS
: BOTTOM@ BOTTOM @ ;
: PREV_BLK@ PREV_BLK @ ;
: GET_NEXT_SIZE PREV_BLK@ BPW+ @ ;
: GET_NEXT PREV_BLK@ @ ;
: USER@ USER @ ;
: USERBPW+ USER BPW+ ;

: GRABALL
	GET_NEXT_SIZE				( NEWSIZE --> )
	GET_NEXT BPW+ SWAP		( *FREE SIZE --> FIRST FREE WORD )
	GET_NEXT						( *FREE SIZE *LINK --> SET CNT LATER )
	DUP BPW+ @					( *FREE SIZE *LINK GET_NEXT_SIZE --> )
	PREV_BLK@ BPW+ !			( *FREE SIZE *LINK --> MOVE SIZE )
	DUP @ PREV_BLK@ ! 		( *FREE SIZE *LINK --> MOVE LINK )
	!								( *FREE --> PUTCOUNT IN FREE-4 )
;

// HEADS
: GETMEM  ( SIZE -- ADDR|FALSE )
	MEMLINK PREV_BLK !
	BPW+ USER !											( SAVE NUMBER @ USER )
		BEGIN
			GET_NEXT NOT NOT					( T/F --> )
			GET_NEXT_SIZE USER@ < AND					( T/F --> )
		WHILE										( VALID PTR )
			GET_NEXT PREV_BLK !       		( follow the link )
		REPEAT
		GET_NEXT 0=                  		( have we found a useable block ? )
			IF ( FAIL )                   ( no return FALSE )
				FALSE EXIT
			THEN
		GET_NEXT_SIZE USER@ - [ HOSTBPW 2 * XLITERAL ]
		<                       ( would we leave a fragment  < 2words )
		IF                               ( yes ; give user whole block )
				GRABALL
		ELSE
				GET_NEXT BPW+ 				( *FREE --> address of available mem )
				GET_NEXT_SIZE USER@ -   ( *FREE FRAGSIZE --> size of fragment )
				PREV_BLK@ BPW+ !			( *FREE --> save in previous size )
				GET_NEXT						( *FREE *LINK --> remember link to next )
				DUP USER@ + PREV_BLK@ !	( *FREE *LINK --> adjust previous link )
				DUP @ GET_NEXT !			( *FREE *LINK --> save new link to next )
				BPW+ @ PREV_BLK@   		( *FREE *LINK
				@ BPW+ !             	( *FREE --> store size of next block )
				USER@ OVER BPW- !			( *FREE --> store size in free - bpw
		THEN
;
( do GETMEM and abort if out of memory )
// HEADERLESS
: DIE?
	DUP
	NOT IF HOSTABORT" Out of memory !!" THEN
;
// HEADS
: GETMEMABORT  ( SIZE -- FIRST-BYTE )
	GETMEM DIE?
;

: GETHIMEM  ( SIZE -- ADDR|FALSE )
	0 USERBPW+ !
	MEMLINK PREV_BLK !
	BPW+ USER !											( SAVE NUMBER @ USER )
		BEGIN
			GET_NEXT NOT NOT					( T/F --> )
		WHILE										( WHILE SIZE TO SMALL AND VALID PTR )
			USER@ GET_NEXT_SIZE <
				IF		( T/F --> )
					PREV_BLK@ USERBPW+ !
				THEN
			GET_NEXT PREV_BLK !       		( follow the link )
		REPEAT
		USERBPW+ @ 0=                  	( have we found a useable block ? )
			IF ( FAIL )                   ( no return FALSE )
				FALSE EXIT
			THEN
		USERBPW+ @ PREV_BLK !
		GET_NEXT_SIZE USER@ - [ BPW 2 * XLITERAL ]
		<                       ( would we leave a fragment  < 2words )
		IF                               ( yes ; give user whole block )
				GRABALL
		ELSE
				GET_NEXT_SIZE USER@ -   	( FRAGSIZE --> size of fragment )
				PREV_BLK@ BPW+ !			( --> save in previous size )
				GET_NEXT_SIZE GET_NEXT + 			( *NEWBLK -->
				USER@ OVER !						( *FREE --> store size in free - bpw )
				BPW+
		THEN
;
( link a block into the free-list ;merging where possible )
: GETHIMEMABORT  ( SIZE -- FIRST-BYTE )
	GETHIMEM DIE?
;

: FREEMEM   ( LINKADDR -- )
( ." Freemem " CR
	MEMLINK PREV_BLK !
	0 PREV_LINK !
	BPW- DUP DUP BOTTOM !
	@ + TOP !
( BOTTOM is bottom of freemem which also is the free size word )
( Find block just before freemem )
			BEGIN
				PREV_BLK@ @ NOT NOT
				GET_NEXT BOTTOM@ < AND
			WHILE
				PREV_BLK@ PREV_LINK !
				GET_NEXT PREV_BLK !
			REPEAT
( PREV_BLK has addres of prev block )
( see if the previous and released block can be merged )
				PREV_LINK @
					IF
					  ( CALC END OF PREVIOUS BLOCK )
						PREV_LINK @ BPW+ @ ( get previous
						PREV_LINK @ @ +    ( previous start+size=end )
					ELSE 0
					THEN
				BOTTOM@ =
				IF 							( MERGE BOTTOM WITH PREVIOUS
( ." merge with previous " CR
					BOTTOM@ @ 				( get size of freemem )
					PREV_LINK @ BPW+ @  +   ( add size of prev block )
					PREV_LINK @ BPW+  !     ( this is the next prev size )
				ELSE ( LINK TO PREVIOUS )
( ." link to previous " CR
					GET_NEXT						( NXTBLK --> get next blk )
					GET_NEXT_SIZE				( NB NEXTSIZE --> getnext size )
					BOTTOM@ @				   ( NB NS FREESIZE --> get freesize )
					PREV_BLK@ BPW+ !			( NB NS --> save FS into prevblk )
					BOTTOM@ PREV_BLK@ !	   ( NB NS --> link previous to free )
					BOTTOM@ BPW+ !          ( NB --> link free to next )
					BOTTOM@ !           ( --> save next size in free )
					PREV_BLK@ PREV_LINK !	( --> point prevlink to prevblk )
					BOTTOM@ PREV_BLK !			( --> point prevblk to free )
				THEN
( now check if the next two block can merge )
					TOP @
					GET_NEXT
					 =
						IF 						( yes merge them )
( ." Merge with next " CR
						  GET_NEXT GET_NEXT_SIZE + ( END --> end of next block )
						  GET_NEXT @ PREV_BLK@
						  GET_NEXT BPW+ @ PREV_BLK@ BPW+ ! ! ( END --> move link )
						  PREV_BLK@ -			  ( SIZE --> size of merged blk )
						  PREV_LINK @ BPW+ !		  ( --> save new size )
						THEN
( ." end freemem " CR
;

// HOSTECHO ON
// file descriptor and buffer layout - MODIFIED FOR 32BIT ARM )
// 0 PREVIOUS ; link to previous descriptor or null )
// 4 (2) FP ; 32 bits file pointer as returned by openfile )
// 8 (6) INDEX ; pointer to next char to be read from buffer )
// C (8) LIMIT ; address of byte after last valid char in buffer )
// 10 (b) LINENO ; current line of this file for error routine )
// 14 (d) EOF ; flag to indicate that there's no more file left to load )
// 18 (e) BUFFER ; file buffer )
// 18 (e)+buffsize FILENAME ; char array h'40 bytes long  )
// to remember filename in case of error )
// total size = 58 + buffsize

: CLOSEFILE  ( FP --  was FPHI FPLO -- )
  &FSERVE HEADER
  1 WRITEC
  [ close M> XLITERAL ] WRITE2C
  4 WRITE4C
	WRITE4C
	GETACKTODROP
;

: CLOSEFP           ( &fp -- )
	@				(  )
	CLOSEFILE
;

: READFILE        ( fp size &buffer -- fp acsize )
// ." RF " CR
	&FSERVE HEADER
	1 WRITEC
	[ read M> XLITERAL ] WRITE2C
	8 WRITE4C
	3 PICK WRITE4C    // WRITE FP 
	SWAP WRITE4C	   // SIZE	
( now we wait for the request to be serviced )
	GETACKTODROP   ( this should read the packet up to the data we want )
	DATASIZE @   ( &BUFF DATASIZE --
	BEGIN
		DUP
	WHILE
		SWAP 	( FP DATASIZE &BUFF --
		SINTO	( FP DATASIZE &BUFF DATABYTE --
		OVER C! ( FP DATASIZE &BUFF
		1+ SWAP
		1-
	REPEAT		( FP DATASIZE
	DROP DROP
	DATASIZE @
;

( HEADERLESS
HOSTBUFFERSIZE	CONSTANT BUFFSIZE         			( length of disk buffer )

: GETBLK    ( --- )
// ." GB" CR
	BLK@ >R
	I 18 + I 8 + !        				( set up index to point to bufferstart )
	I 4 + @ ( get fp )
	BUFFSIZE I 18 +  					( PF SIZE *BUFF -- )
	READFILE             				( PF  ACSIZE -- )
	DUP I 18 + + I C + !  				( PF  ACSIZE -- set up limit )
	DUP 0 < IF HOSTABORT" FILE ERROR " THEN
	BUFFSIZE = NOT R> 14 + C!  			( set eof )
	DROP 								( -- )
;

( HEADS
: -ENDLINE
	>IN @ CNT !
	0 >IN !	
;

: -[GETLINE]
	BLK@ DUP 4 + 
	CLOSEFP
	DUP @ DUP BLK !		( unlink this buffer )
	NOT IF 
		ECHO ON 
	THEN
// ." FREEMEM " .S
	FREEMEM
	0D >TIB
	-ENDLINE
;

( HEADERLESS
: XGETLINE ( INDX -- )
	BLK@ 8 + !             ( save index )
	1 BLK@ 10 + +! 						( INC LINE NO
	20 >TIB ( 20 # LDAA, 0 ,Y STAA, 	( SAVE IN TIB )
	-ENDLINE	
;

VARIABLE CRFLG
VARIABLE LIMIT
( HEADS
: [GETLINE] // Get a line from a file buffer to the text input buffer.
	0 CRFLG !	
	0 >IN !							( clear CR FLAG )
	BLK@		( LDX,						( BLK -- 
	DUP C + @ 								( GET LIMIT )
	LIMIT !
	8 + @       							( INDX -- get index to TOP ( X )
	BEGIN
		DUP LIMIT @  						( INDX INDX LIMIT -- GET LIMIT )
		= IF
		DROP
			BLK@ 14 + C@ IF					(  -- end of file EXIT )
				-[GETLINE]
				EXIT
			THEN
			GETBLK
			BLK@ 8 + @      			( get new index to X )
		ELSE
			DUP C@	    					(  INDX CHAR -- get byte from buffer )
			DUP A							(  INDX CHAR T/F -- is lf found )
			= IF
				DROP 1+
				XGETLINE
				EXIT
			THEN
			CRFLG @							(  INDX CHAR CRFLG --
			IF
				DROP
				XGETLINE
				EXIT
			THEN
			DUP D 
			= IF							( INDX CHAR  --
				TRUE CRFLG !				( MARK CR FOUND )
			ELSE
				DUP 9 						( INDX CHAR --  is it tab )
				= IF
					DROP 20 				( INDX 20 --  drop convert tab to space )
				THEN
			THEN
			>TIB
			1+ 
		THEN
	AGAIN
;

VARIABLE DEBUGCOUNT
// HOSTECHO ON
: SERVGETLINE
	0 >IN !	
	BLK@ IF
		[GETLINE]
		ECHO @ 
		IF // .S
//			CNT @ IF
			CNT @ 2 - 0 DO I TIB + C@ EMIT LOOP CR 
//			THEN
		THEN
	ELSE
			&KBD HEADER
			1 WRITEC
			[ getline M> XLITERAL ] WRITE2C		  
			0 WRITE4C
			-1 GETACK
  		NOT IF *ABORT @ EXECUTE THEN
			BEGIN
				DATASIZE @ >IN @ - // While >IN != datasize 
			WHILE
				SINTO 
				>TIB
			REPEAT
		D >TIB				// -- save a CR char
		-ENDLINE	
	THEN
; 

HOST' SERVGETLINE ADDRSERVGETLINE HOST!

: GETNAME   ( -- *TEXT )
	20 WORD DUP
	C@ NOT IF
	DROP ." Filename Please -" CR GETLINE 20 WORD
	THEN
;

// HEADERLESS
: SRVHEAD            ( send sysnc address header to FSERVE )
  &FSERVE         ( address of fileserver path info )
  HEADER         	( send packet header )
;
( send filename and receive filepointer )
: GETFPETC.          ( &TEXT -- FP TRUE | FALSE )
  DUP C@ DUP WRITE4C ( &TEXT CNT --  string count byte send as 32 bits )
  OVER + 1+ SWAP 1+     ( &LASTCHAR &FIRSTCHAR -- )
	DO
		I C@         			( get char from filename )
		WRITEC					( send it )
	LOOP
	GETACKTODROP             		( wait for acknowlege packet )
  DATASIZE @         	( get the size of the data field )
  4 =              		( is it 4 )
  IF                		( yes assume it's a file pointer )
	  READ4C    			( GET FILE POINTER )
	  TRUE
  ELSE                  ( it's not 4 there must be an error )
	  FALSE           	( load false )
  THEN
;
( HEADS
MP!

: OPENREADFILE   		( &TEXT -- FP TRUE | FALSE )
	SRVHEAD
	2 WRITEC 					( 2 messages to send)
	[ open M> XLITERAL ]     ( the first message is open )
	WRITE2C          			( send it )
	[ read M> XLITERAL ]     ( the second is read )
	WRITE2C          			( send it )
	GETFPETC.               ( open it get fp etc)
;

: OPENWRITEFILE   		( &TEXT -- FP TRUE | FALSE )
	SRVHEAD
	2 WRITEC 					( 2 messages to send)
	[ open M> XLITERAL ]     ( the first message is open )
	WRITE2C          			( send it )
	[ write M> XLITERAL ]     ( the second is write )
	WRITE2C          			( send it )
	GETFPETC.               ( open it get fp etc)
;

( HEADERLESS
: [-WRT]                   ( send a header and "write" the fserver )
	SRVHEAD         			 	( send header )
	1 WRITEC         				( send 1 message to server )
	[ write M> XLITERAL ]    ( the message is write )
	WRITE2C          				( send it )
;

: [FP2ND]                  ( FP N -- FP  send number and fp )
	WRITE4C
	DUP
	WRITE4C
;
( HEADS
: WRITEC_FILE ( fphi fplo byte - fp )
	[-WRT]           		( send header + write msg )
	>R                   	( save byte )
	5          				( 5 bytes to send)
	[FP2ND]          		( send size + fp )
	R>					    ( get byte to send )
	WRITEC           		( send it )
	GETACKTODROP           		( wait for ack )
;

: WRITE2C_FILE ( fphi fplo 16bit - fp )
	[-WRT]           		( send header + write msg )
	>R                   	( save word16 )
	6          				( 6 bytes to send)
	[FP2ND]          		( send size + fp )
	R>					    ( get word16 to send )
	WRITE2C           		( send it )
	GETACKTODROP          	( wait for ack )
;

: WRITEPAD32_FILE ( fphi fplo 16bit - fp )
	[-WRT]           		( send header + write msg )
	>R                   	( save word16 )
	8          				( 8 bytes to send)
	[FP2ND]          		( send size + fp )
	R>					    ( get word16 to send )
	WRITE2C           		( send it )
	0 WRITE2C				( pad it with 2 zeros )
	GETACKTODROP           		( wait for ack )
;

: WRITE_FILE ( fp &data size - fp )
	[-WRT]           		( send header + write msg )
	SWAP >R                 ( save &data )
	>R                      (  FP -- save size )
	I 4 +          		    ( size + 4 bytes to send)
	[FP2ND]          		( send size + fp )
	R>					    ( get size )
	I						( get &data )
	+ 						( calc addr of end of data + 1 )
	R>                      ( get data address )

	DO
		I C@ WRITEC         ( send databyte )
	LOOP
	GETACKTODROP          	( wait for ack )

;

: -INCLUDE       ( -- )
	OPENREADFILE
	IF
	." FILE OPENED " CR
		ECHO OFF        				( fp --  )
		[ HOSTBUFFERSIZE 58 HOST+ XLITERAL ] GETHIMEMABORT
		.S
		>R
		BLK@ I !                  ( fph fpl -- save old blk in previous )
		I BLK !				  	( fph fpl -- point blk to fd )
		I 4 + !					  ( -- save pf )
		0 I 10 + !                 ( zero line no. )
		PAD
		[ HOSTBUFFERSIZE 18 HOST+ XLITERAL ] R> +
		PAD C@ 1+ CMOVE           ( Move file name into fd )
		GETBLK
//	[ HOST.S ]
	ELSE
			HOSTABORT" CAN'T OPEN FILE "
	THEN
;

 : INCLUDE GETNAME -INCLUDE ;

: CAPTURE
	CAPFP @ 0= IF
		GETNAME
		OPENWRITEFILE
		IF
			CAPFP !
		ELSE
			HOSTABORT" CAN'T OPEN FILE "
		THEN
	ELSE
		CAPFP CLOSEFP 
		CAPFP 0!
		." Capture file closed " CR
	THEN
;

: STDOUT
	STDOUTFP @ 0= IF
		GETNAME
		OPENWRITEFILE
		IF
			STDOUTFP !
		ELSE
			HOSTABORT" CAN'T OPEN FILE "
		THEN
	ELSE
		STDOUTFP CLOSEFP
		STDOUTFP 0!
		." Standard Out file closed " CR
	THEN
;


: -[CAP]
		&FSERVE     ( address of vdu data table into Y )
		HEADER        ( send header )
		1 WRITEC         ( 1 message )
		[ write M> XLITERAL ]      ( the message is "write" )
		WRITE2C
		OUTCNT @         	( get no. of char in buffer )
		4 +         	( ADD 4 for fp )
		WRITE4C      	( send as data size )
;
// HOSTECHO ON
// HOSTHERE HOST. HOSTCR 
// HOSTECHO OFF
: SERVCR 
	0D EMIT	
	0A EMIT
	CAPFP @
	IF
		-[CAP]
		CAPFP @    ( get fp )
		WRITE4C
		[SENDTOB]
		GETACKTODROP
	THEN
	STDOUTFP @
	IF
		-[CAP]
		STDOUTFP @ ( get fp )
		WRITE4C
		[SENDTOB]
		GETACKTODROP
	ELSE
		&VDU       ( address of vdu data table into Y )
		HEADER        ( send header )
		1 WRITEC          ( 1 message )
		[ type M> XLITERAL ]     ( the message is "type" )
		WRITE2C
		OUTCNT @       ( get no. of char in buffer )
		WRITE4C       ( send as data size )
		[SENDTOB]
		GETACKTODROP
	THEN
  OUT!					( ZERO >OUT )
;

HOST' SERVCR ADDRSERVCR HOST.S HOST!

COMPILER DEFINITIONS

: CALL 
	' BRLNK
;

: BR EA000000  -BR	;				// CODE ADDR--

: GOTO 
	' BR
;

// HOSTECHO ON
FORTH DEFINITIONS 

: CR *PUTLINE @ EXECUTE ;
: PINGSERV	( -- CHAR )
	&KBD HEADER
	1 WRITEC
	[ hit M> XLITERAL ] WRITE2C
	0 WRITE4C
	GETACKTO
;

: >FILE // START SIZE -- MT;
  GETNAME                     ( &FILENAME )
  OPENWRITEFILE               ( FP T/F -- )
	IF
		." Writing file " CR
		ROT ROT  
		WRITE_FILE       ( FP -- )
		CLOSEFILE                ( -- )
//		DROP
	ELSE
		DROP DROP DROP ." FILE CREATION FAILED "
	THEN
;

: SOURCE
	CONFIGURE INCLUDE
;
// 'SMUD LITERAL
: LITERAL
	[ ADDR[LIT] HOST@ XRLITERAL ] BRLNK		( Make a call to [LIT] 
	, 			( Store literal value from top
;

: RLITERAL
	[ ADDR[RLIT] HOST@ XRLITERAL ] BRLNK		( Make a call to [LIT] 
	HERE BPW+ - , 			( Store relative literal value from top
;


: INIT 
	SP!
	FORTHONLY 
	HEX
	OUT! 
;

RUNTIME DEFINITIONS 
// CREATE CRAP3
FFFFFC10 CONSTANT PMC_PCER // (PMC) Peripheral Clock Enable Register
2 CONSTANT ID_PIOA     // Parallel IO Controller bit
6 CONSTANT ID_US0      // USART 0
7 CONSTANT ID_US1      // USART 0
 // ========== Register definition for usart peripheral ==========

1 2 LSHIFT CONSTANT US_RSTRX // (DBGU) Reset Receiver
1 3 LSHIFT CONSTANT US_RSTTX // (DBGU) Reset Transmitter
1 4 LSHIFT CONSTANT US_RXEN  // (DBGU) Receiver Enable
1 5 LSHIFT CONSTANT US_RXDIS // (DBGU) Receiver Disable
1 6 LSHIFT CONSTANT US_TXEN  // (DBGU) Transmitter Enable
1 7 LSHIFT CONSTANT US_TXDIS // (DBGU) Transmitter Disable
1 8 LSHIFT CONSTANT RSTSTA   // (DBGU) Reset Status Bits

// ========== Register definition for PIOA peripheral ==========
FFFFF404 CONSTANT PIOA_PDR   // (PIOA) PIO Disable Register
DECIMAL
// 1 21 LSHIFT CONSTANT PA21_RXD1 
// 1 22 LSHIFT CONSTANT PA22_TXD1 

0 CONSTANT US_USMODE_NORMAL  // (USART) Normal
0 4 LSHIFT  CONSTANT US_CLKS_CLOCK    // (USART) Clock
0 12 LSHIFT CONSTANT US_NBSTOP_1_BIT  // (USART) 1 stop bit
4 9 LSHIFT  CONSTANT US_PAR_NONE      // (DBGU) No Parity
3 6 LSHIFT  CONSTANT US_CHRL_8_BITS   // (USART) Character Length: 8 bit
HEX

FFFFFD00  	CONSTANT base_RSTC		
8	  		CONSTANT RSTC_MR 		
1  			CONSTANT RSTC_URSTEN


LABEL INIDATA // Data to initialize uart etc

// set up usart 0
// Reset Receiver Reset Transmitter  Receiver Disable  Transmitter Disable 
BASE_US0 , US_RSTRX US_RSTTX US_RXDIS US_TXDIS OR OR OR , // same as US_CR 

// Normal Mode Clock = MCK No Parity 1 Stop Bit 
BASE_US0 US_MR + , US_USMODE_NORMAL US_CLKS_CLOCK US_CHRL_8_BITS US_PAR_NONE US_NBSTOP_1_BIT OR OR OR OR ,

//  Baud Rate Divisor 38.4Kbd with 48mhz clock = 78, 115 = 26

BASE_US0 US_BRGR + , DECIMAL 26 HEX ,

//  Receiver Enable  Transmitter Enable  
BASE_US0 , US_RXEN US_TXEN OR ,

// set up usart 1
// Reset Receiver Reset Transmitter  Receiver Disable  Transmitter Disable 
BASE_US1 , US_RSTRX US_RSTTX US_RXDIS US_TXDIS OR OR OR , // same as US_CR 

// Normal Mode Clock = MCK No Parity 1 Stop Bit 
BASE_US1 US_MR + , US_USMODE_NORMAL US_CLKS_CLOCK US_CHRL_8_BITS US_PAR_NONE US_NBSTOP_1_BIT OR OR OR OR ,


//  Baud Rate Divisor 38.4Kbd with 48mhz clock = 78, 115 = 26

BASE_US1 US_BRGR + , DECIMAL 26 HEX ,

//  Receiver Enable  Transmitter Enable  
BASE_US1 , US_RXEN US_TXEN OR ,

//  p_pPMC->PMC_PCER = 1 << AT91C_ID_PIOA;
PMC_PCER , 1 ID_PIOA LSHIFT 1 ID_US0 LSHIFT 1 ID_US1 LSHIFT OR OR ,

//  p_pPio->PIO_PER = BIT8;    //Enable PA8 for led
PIO_PER	,	INITPER ,

//  p_pPio->PIO_OER = BIT8;    //Configure in Output
PIO_OER , INITOER ,
PIO_OER-B , INITOER-B ,						

// *AT91C_RSTC_RMR = 0xA5000000|AT91C_RSTC_URSTEN ;
base_RSTC RSTC_MR + , A5000000 RSTC_URSTEN OR ,
0 ,


: INITPORTS
// FFFFF240 - ID :  275 = X 270 = S

	FFFFF240 @ // Get chip ID
	FFF00000 AND 
	27500000 = IF // X256
		63
	ELSE
		600060
	THEN
	PIOA_PDR !
	
	INIDATA
	BEGIN
		DUP @ // While not pointing to a zero
	WHILE
		 DUP 4 + @ 		// PTR, DATA -- 
		 OVER @			// PTR, DATA STOREADDR -- 
			! 
		 8 + 
	REPEAT
	DROP
;

COMPILER
// reset vector points here. Probably running in flash with nothing initialized yet.
CREATE BOOT // Use create instead of : to avoid stack push before ram is up.
 ] RESET // intialize arm memory controls, clock etc.
	INITPORTS	// bring up coms and io ports.
	4 0 DO LEDON DELAY LEDOFF DELAY LOOP // show some life.
	LR@
	RAM <
	IF
		FREETOP 100000 - FREETOP DSTACK OVER - CMOVE 
		100000 200000 DP @ OVER - CMOVE 
	THEN
	*COLD @ EXECUTE // run forth 
 [ // no need for ; because abort never returns here.


HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 20 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 24 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 28 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 2C HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 30 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 34 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 38 HOST+ HOST!
HOST' BOOT HOST' ARM HOST- 100000 HOST+ HOST' ARM 3C HOST+ HOST!

FORTH DEFINITIONS

'SMUD CREATE
: CREATE // A new version of create which has more flag options.
	2 ALIGNDP HERE 
	DUP LATEST  !
	CURRENT @ @ ,	( Store link 
	CURRENT @ !	
	0 C, 						( Store flags )
	20 WORD						( parse name of word to create -- PAD
	DUP C@ 1+					( Get length Add 1 for cnt byte
	BEGIN						( LFA PAD CNT
		SWAP DUP C@ C, 			( Store char to dic.
		1+ SWAP 1-				( Inc pad swap to get cnt
		DUP 
	0= 	UNTIL
	DROP DROP
;

'SMUD DEFINITIONS 
: DEFINITIONS CONTEXT CURRENT ! ;
COMPILER
: QUIT
	RP! OP! MP!
	INIT 
	ECHO ON
." EMFORTH v1.74 for the SAM7 ARM micro controller" CR
." E.Matejowsky 2007" CR
	BEGIN					// begin interpreter loop 
	GETLINE					// get a line for input stream
	BEGIN 					// begin parse loop 
		20 WORD C@			// parse a string delimited by a space
	WHILE					// if a string was found continue, if not go to past the repeat. 
		FIND				// looks for the word in the dictionary
		DUP IF				// dup the address and goto "else" if it was zero ie not found.
			LFA>CA EXECUTE 	// the word exists, convert the link address to the code address and execute it.  
		ELSE 
			DROP NUMBER		// the word was not found, drop the address and convert the string to number.
		THEN
	REPEAT 					// repeat the parse loop 
		ECHO @ IF 
			CR 3E EMIT // send prompt
			CR						// send a return to the terminal. 	
		THEN
	AGAIN					// execute the interpret loop again.
;

: ABORT CAPFP 0! STDOUTFP 0! BLK 0! QUIT ;


: COLD *COLD @ EXECUTE ;


'SMUD //
: // 0 WORD DROP ;
COMPILER
'SMUD ]
HOST' ADDRSERVCR HOST. HOSTCR
: ] COMPILER
	MODE @ 1 OR MODE ! 			( Set mode to compile )
	BEGIN 				( begin compile loop )
 	MODE @ ( 1 =			( check we are still in compile mode )
	WHILE	
		BEGIN			
 			20 WORD	C@	( try to parse a word
		0= WHILE		( if 0 no word parsed so get a new line 
 		ECHO @ IF CR THEN
 			 GETLINE
		REPEAT			( repeat until a word is parsed )
 		FIND			( look for the word in the dictionary )
		DUP IF 			( in not zero we found one 
 			DUP 4 + C@ 	( GET flags
 			F_IMMD AND 	( Check immediate flag )
			IF
 				LFA>CA 
				EXECUTE	( it was immediate so execute it. )
			ELSE 
				LFA>CA
				BRLNK	( it wasn't immediate so compile a call to it.
			THEN
		ELSE 
			DROP				( word not in dictionary )
			NUMBER				( convert string to number and compile a literal )
			LITERAL 			( Make a call to [LIT] 
		THEN 
 	REPEAT						( repeat until the mode is not compile )
;

: LRPUSH E92D4000 , ;
: PCPOP E8BD8000 , ;

HOST' ADDRSERVCR HOST. HOSTCR

COMPILER HOSTDEFINITIONS

: [ COMPILER VDROP
	0 MODE ! ( Set mode to interp )
;
COMPILER 
'IMMEDIATE [

: ;
	0  MODE  ! ( Set mode to interp )
	PCPOP
	COMPILER VDROP
HOST;
HOST' ADDRSERVCR HOST. HOSTCR
FORTH HOSTDEFINITIONS
HOST: :	
	CREATE
	LRPUSH 
	]
HOST;	
RUNTIME HOSTDEFINITIONS FORTH
VARIABLE VARPTR

HOST' ADDRSERVCR HOST. HOSTCR

HOST: BOOTSRV ( LOTSA DRAGONS
	DELAY	
 HOSTBLK@	
HOSTBLK@ HOST. HOSTCR
( BLK@
	DUP 4 + CLOSEFP
	HOSTBLK 0!
	BLK 0!
	RP! OP! MP!
	INIT
	
	CONFIGURE	
	FLASHLED
  	ADDRSERVCR @ *PUTLINE !	
	ADDRSERVGETLINE @ *GETLINE !
	20 HOSTWORD -INCLUDE ( HOSTBLK @ BLK !
	ECHO OFF
QUIT
HOST;

HOST: BOOTNEW 
	BLK 0!
	RP! OP! MP!
	INIT
  	ADDRSERVCR @ *PUTLINE HOST.S !	
	ADDRSERVGETLINE @ *GETLINE HOST.S !
(	HOST.S
	CONFIGURE	
(	FA50 20 HOSTDUMP
 ABORT
HOST;	

'IMMEDIATE //

COMPILER 
'IMMEDIATE ;

HOSTHERE DP HOST.S !
HOSTHERE HOST. HOSTCR

ADDRFORTH PATCHVOC
ADDRRUNTIME PATCHVOC
ADDRCOMPILER PATCHVOC
ADDRASSEMBLER PATCHVOC

HOSTECHO ON
( BOOTNEW

BOOTSRV RELOC.FTH
